Package: CNVfilteR
Type: Package
Title: Identifies false positives of CNV calling tools by using SNV
        calls
Version: 1.26.0
Authors@R: 
    c(person(
        given = "Jose Marcos",
        family = "Moreno-Cabrera",
        role = c("aut", "cre"),
        email = "jpuntomarcos@gmail.com",
        comment = c(ORCID = "0000-0001-8570-0345")
    ), person(
        given = "Bernat",
        family = "Gel",
        role = "aut"
    ))
Description: CNVfilteR identifies those CNVs that can be discarded by using the single nucleotide variant (SNV) calls that are usually obtained in common NGS pipelines.
License: Artistic-2.0
URL: https://github.com/jpuntomarcos/CNVfilteR
Encoding: UTF-8
RoxygenNote: 7.1.1
Depends: R (>= 4.3)
Imports: IRanges, GenomicRanges, SummarizedExperiment, pracma,
        regioneR, assertthat, karyoploteR, CopyNumberPlots, graphics,
        utils, VariantAnnotation, Rsamtools, GenomeInfoDb, Biostrings,
        methods
Suggests: knitr, BiocStyle, BSgenome.Hsapiens.UCSC.hg19,
        BSgenome.Hsapiens.UCSC.hg19.masked, rmarkdown
biocViews: CopyNumberVariation, Sequencing, DNASeq, Visualization,
        DataImport
VignetteBuilder: knitr
BugReports: https://github.com/jpuntomarcos/CNVfilteR/issues
git_url: https://git.bioconductor.org/packages/CNVfilteR
git_branch: RELEASE_3_23
git_last_commit: 65126b1
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 21:19:45 UTC; biocbuild
Author: Jose Marcos Moreno-Cabrera [aut, cre] (ORCID:
    <https://orcid.org/0000-0001-8570-0345>),
  Bernat Gel [aut]
Maintainer: Jose Marcos Moreno-Cabrera <jpuntomarcos@gmail.com>

# CNVfilteR
R package to remove false positives of CNV calling tools by using SNV calls


## Introduction

Many tools for germline copy number variant (CNV) detection 
from NGS data have been developed. Usually, these tools were 
designed for different input data like WGS, WES or
panel data, and their performance may depend on the CNV size. Available
benchmarks show that all these tools obtain false positives, sometimes 
reaching a very high number of them.

With the aim of reducing the number of false positives,
[CNVfilteR](http://bioconductor.org/packages/CNVfilteR) identifies those 
germline CNVs that can be discarded. This task is performed by using the 
germline single nucleotide variant (SNV) calls that are usually 
obtained in common NGS pipelines. As VCF field interpretation is key 
when working with these files, CNVfilteR specifically supports 
VCFs produced by VarScan2, Strelka/Strelka2, freeBayes, HaplotypeCaller, 
UnifiedGenotyper and Torrent Variant Caller. Additionally, results can be 
plotted using the functions provided by the R/Bioconductor packages
[karyoploteR](http://bioconductor.org/packages/karyoploteR/) and 
[CopyNumberPlots](http://bioconductor.org/packages/CopyNumberPlots/).




## How to use it

Documentation ([vignette](http://bioconductor.org/packages/devel/bioc/vignettes/CNVfilteR/inst/doc/CNVfilteR.html) and [user manual](http://bioconductor.org/packages/devel/bioc/manuals/CNVfilteR/man/CNVfilteR.pdf)) are available at the [CNVfilteR](http://bioconductor.org/packages/CNVfilteR) 
Bioconductor site, allow with instructions to install it.


## Citation

CNVfilteR was developed by José Marcos Moreno-Cabrera and Bernat Gel. For citations,
please refer to the [Bioinformatics paper](https://academic.oup.com/bioinformatics/advance-article/doi/10.1093/bioinformatics/btab356/6275259): 

José Marcos Moreno-Cabrera, Jesús del Valle, Elisabeth Castellanos, Lidia Feliubadaló, Marta Pineda, Eduard Serra, Gabriel Capellá, Conxi Lázaro, Bernat Gel, *CNVfilteR: an R/Bioconductor package to identify false positives produced by germline NGS CNV detection tools*, Bioinformatics, 2021;, btab356, [https://doi.org/10.1093/bioinformatics/btab356](https://doi.org/10.1093/bioinformatics/btab356)

#' filterCNVs
#'
#' @description
#' Identifies those copy number calls that can be filtered out
#'
#' @details
#' Checks all the variants (SNV and optionally INDELs) in each CNV present in \code{cnvs.gr} to decide whether a CNV can be filtered out or not.
#' It returns an S3 object with 3 elments: \code{cnvs}, \code{variantsForEachCNV} and \code{filterParameters}. See return section for further details.
#'
#' A CNV deletion can be filtered out if there is at least \code{ht.deletions.threshold}% of heterozygous variants in the CNV.
#' A CNV duplication can be filtered out if the \code{score} is >= \code{dup.threshold.score} after computing all heterozygous variants falling in the CNV.
#'
#' If a CNV can be filtered out, then the value TRUE is set in the \code{filter} column of the \code{cnvs} element.
#'
#' @param cnvs.gr \code{GRanges} containing CNVs to be filtered out. Use \code{loadCNVcalls} to load them.
#' @param vcfs List of \code{GRanges} containing all variants (SNV/indel) obtaining with the \code{loadVCFs} function.
#' @param expected.ht.mean Expected heterozygous SNV/indel allele frequency (defaults to 50)
#' @param expected.dup.ht.mean1 Expected heterozygous SNV/indel allele frequency when the variant IS NOT in the same allele than the CNV duplication call. (defaults to 33.3)
#' @param expected.dup.ht.mean2 Expected heterozygous SNV/indel allele frequency when the variant IS in the same allele than the CNV duplication call. (defaults to 66.6)
#' @param sigmoid.c1 Sigmoid c1 parameter. (defaults to 2)
#' @param sigmoid.c2.vector Vector containing sigmoid c2 parameters for the six sigmoids functions. (defaults to c(28, 38.3, 44.7, 55.3, 61.3, 71.3))
#' @param dup.threshold.score Limit value to decide if a CNV duplication can be filtered out or not. A CNV duplication can be filtered out if the total score computed from heterozygous variants in the CNV is equal or greater than \code{dup.threshold.score}.  (defaults to 0.5)
#' @param ht.deletions.threshold Minimum percentage of heterozygous variants falling in a CNV deletion to filter that CNV. (defaults to 30)
#' @param margin.pct Variants in the CNV but close to the ends of the CNV will be ignored. \code{margin.pct} defines the percentage
#'  of CNV length, located at each CNV limit, where variants will be ignored. For example, for a CNV chr1:1000-2000 and
#'  a \code{margin.pct} value of 10, variants within chr1:1000-1100 and chr1:1900-2000 will be ignored.
#' @param verbose Whether to show information messages. (defaults to TRUE)
#'
#' @return
#' A S3 object with 3 elements:
#' \itemize{
#' \item \code{cnvs}: \code{GRanges} with the input CNVs and the meta-columns added during the call:
#'   \itemize{
#'    \item \code{cnv.id}: CNV id
#'    \item \code{filter}: Set to TRUE if the CNV can be filtered out
#'    \item \code{n.total.variants}: Number of variants in the CNV
#'    \item \code{n.hm.variants}: Number of homozygous variants. They do not give any evidenced for confirming or discarding the CNV.
#'    \item \code{n.ht.discard.CNV}: For a CNV duplication, number of heterozygous variants in that discard the CNV (those with a positive score)
#'    \item \code{n.ht.confirm.CNV}: For a CNV duplication, number of heterozygous variants that confirm the CNV (those with a negative score)
#'    \item \code{ht.pct}: Percentage of heterozygous variants for deletion CNVs
#'    \item \code{score}: total score when computing all the variants scores
#'   }
#' \item \code{variantsForEachCNV}: named list where each name correspond to a CNV id and the value is a \code{data.frame} with all variants falling in that CNV
#' \item \code{filterParameters}: input parameters used for filtering
#'}
#'
#' @examples
#' # Load CNVs data
#' cnvs.file <- system.file("extdata", "DECoN.CNVcalls.csv", package = "CNVfilteR", mustWork = TRUE)
#' cnvs.gr <- loadCNVcalls(cnvs.file = cnvs.file, chr.column = "Chromosome", start.column = "Start", end.column = "End", cnv.column = "CNV.type", sample.column = "Sample")
#'
#' # Load VCFs data
#' vcf.files <- c(system.file("extdata", "variants.sample1.vcf.gz", package = "CNVfilteR", mustWork = TRUE),
#'                system.file("extdata", "variants.sample2.vcf.gz", package = "CNVfilteR", mustWork = TRUE))
#' vcfs <- loadVCFs(vcf.files, cnvs.gr = cnvs.gr)
#'
#' # Filter CNVs
#' results <- filterCNVs(cnvs.gr, vcfs)
#'
#' # Check CNVs that can be filtered out
#' as.data.frame(results$cnvs[results$cnvs$filter == TRUE])
#'
#'
#' @import assertthat
#' @importFrom IRanges subsetByOverlaps IRanges
#' @importFrom GenomicRanges mcols GRanges
#' @importFrom methods is
#' @importFrom regioneR toGRanges
#' @export filterCNVs
#'
filterCNVs <- function(cnvs.gr, vcfs, expected.ht.mean = 50, expected.dup.ht.mean1 = 33.3, expected.dup.ht.mean2 = 66.6,
                       sigmoid.c1 = 2, sigmoid.c2.vector = c(28, 38.3, 44.7, 55.3, 61.3, 71.3),
                       dup.threshold.score = 0.5, ht.deletions.threshold = 30, verbose = FALSE,
                       margin.pct = 10) {

  # Check input
  assertthat::assert_that(methods::is(cnvs.gr, "GRanges"))
  assertthat::assert_that(is.list(vcfs))
  for (v in vcfs){
    if (!methods::is(v, "GRanges"))
      stop("vcfs parameter should be a list of GRanges")
  }
  assertthat::assert_that(assertthat::is.number(expected.ht.mean))
  assertthat::assert_that(assertthat::is.number(expected.dup.ht.mean1))
  assertthat::assert_that(assertthat::is.number(expected.dup.ht.mean2))
  assertthat::assert_that(assertthat::is.number(sigmoid.c1))
  assertthat::assert_that(is.numeric(sigmoid.c2.vector) && length(sigmoid.c2.vector) == 6)
  assertthat::assert_that(assertthat::is.number(dup.threshold.score))
  assertthat::assert_that(assertthat::is.number(ht.deletions.threshold))
  assertthat::assert_that(is.logical(verbose))

  # intersections between two sigmoids curves. For later use
  sigmoid.int1 <- mean(c(expected.dup.ht.mean1, expected.ht.mean))
  sigmoid.int2 <- mean(c(expected.dup.ht.mean2, expected.ht.mean))

  variantsForEachCNV <- list()

  # Filter CNVs depending on variant calls.
  cnvs.df <- as.data.frame(cnvs.gr)  # to speed up the process
  cnvs.df$cnv.id <- ''
  cnvs.df$filter <- ''
  cnvs.df$n.total.variants <- ''
  cnvs.df$n.hm.variants <- ''
  cnvs.df$n.ht.discard.CNV <- ''
  cnvs.df$n.ht.confirm.CNV <- ''
  cnvs.df$ht.pct <- ''
  cnvs.df$score <- ''
  nCNVs <- nrow(cnvs.df)
  for (i in seq_len(nCNVs)){

    cnvId <- toString(i)
    cnvs.df[i, "cnv.id"] <- cnvId

    if (cnvs.df[i, "sample"] %in% names(vcfs)){
      variants <- vcfs[[cnvs.df[i, "sample"]]]
      matchingVariants <- IRanges::subsetByOverlaps(variants, cnvs.gr[i],  type = "any")

      # Filter variants by pct lateral margin
      lateralMargin <- margin.pct / 100.0 * cnvs.df[i, "width"]
      regions.to.include <- GenomicRanges::GRanges(seqnames = cnvs.df[i, "seqnames"],
                                    ranges = IRanges::IRanges(cnvs.df[i, "start"] + lateralMargin, cnvs.df[i, "end"] - lateralMargin))
      matchingVariants <- IRanges::subsetByOverlaps(matchingVariants, regions.to.include,  type = "any")
      matchingVariants.df <- as.data.frame(matchingVariants)  # to speed up the process

      # count number of ht and hm
      htMatchingVariants.indexes <- which(matchingVariants.df$type == "ht")
      htMatchingVariants <- matchingVariants.df[htMatchingVariants.indexes,]
      nHT <- nrow(htMatchingVariants)
      nHM <- nrow(matchingVariants.df[matchingVariants.df$type == "hm",])
      cnvs.df[i, "n.total.variants"] <- nrow(matchingVariants.df)
      cnvs.df[i, "n.hm.variants"] <- nHM

      # if CNV is deletion & ht / (ht + hm)  > ht.deletions.threshold > discard CNV
      if (cnvs.df[i, "cnv"] == "deletion" && nHT > 0 && (nHT / (nHT + nHM) > (ht.deletions.threshold / 100.0) )) {
        cnvs.df[i, "filter"] <- TRUE
        if (verbose){
          message(paste0("CNV deletion at ", toString(cnvs.gr[i]) ," for sample ", cnvs.df[i, "sample"], " can be filtered"))
        }
        cnvs.df[i, "n.ht.discard.CNV"] <- nHT
        cnvs.df[i, "ht.pct"] <- nHT / nrow(matchingVariants.df) * 100.0
      }

      # Add score column for those variants mathching a duplication CNV
      if (cnvs.df[i, "cnv"] == "duplication" & nrow(matchingVariants.df) > 0){
        matchingVariants.df$score <- 0
      }

      # if CNV is duplication  & exists ht
      if (cnvs.df[i, "cnv"] == "duplication" & nHT > 0) {

        total.score <- 0
        discardCNV <- 0
        confirmCNV <- 0
        for (j in seq_len(nHT)){

          # Score variant
          score <- getVariantScore(
            freq = htMatchingVariants[j, "alt.freq"],
            expected.ht.mean = expected.ht.mean,
            expected.dup.ht.mean1 = expected.dup.ht.mean1,
            expected.dup.ht.mean2 = expected.dup.ht.mean2,
            sigmoid.int1 = sigmoid.int1, sigmoid.int2 = sigmoid.int2,
            sigmoid.c1 = sigmoid.c1, sigmoid.c2.vector = sigmoid.c2.vector)

          if(score > 0){
            discardCNV <- discardCNV + 1
          } else if(score < 0) {
            confirmCNV <- confirmCNV + 1
          }

          # compute total score and save score
          total.score <- total.score + score
          matchingVariants.df[htMatchingVariants.indexes[j], "score"] <- score
        }

        # Discard CNV depending on dup.threshold.score
        if (total.score >= dup.threshold.score){
          cnvs.df[i, "filter"] <- TRUE
          if (verbose){
            message(paste0("CNV duplication at ", toString(cnvs.gr[i]) ,
                           " for sample ", cnvs.df[i, "sample"],
                           " can be filtered, score: ", round(total.score, 4)))
          }
        }

        cnvs.df[i, "score"] <- total.score
        cnvs.df[i, "n.ht.confirm.CNV"] <- confirmCNV
        cnvs.df[i, "n.ht.discard.CNV"] <- discardCNV
      }

      if (nrow(matchingVariants.df) > 0)
        variantsForEachCNV[[cnvId]] <- matchingVariants.df
    }
  }

  # Calculate % of CNVs to be filtered
  nFiltered <- nrow(cnvs.df[cnvs.df$filter == TRUE,])
  pct <- round(nFiltered/nCNVs*100, 2)
  message(paste0(nFiltered, " out of ", nCNVs, " (", pct ,"%) CNVs can be filtered"))

  # Calculate % with matching variants to be filtered
  nCNVsWithMatchingVariants <- nrow(cnvs.df[cnvs.df$n.total.variants > 0 ,])
  pct <- round(nFiltered/nCNVsWithMatchingVariants*100, 2)
  message(paste0(nFiltered, " out of ", nCNVsWithMatchingVariants, " (", pct ,"%) CNVs with overlapping SNVs can be filtered"))

  # convert again data.frame to GRanges
  cnvs.gr.final <- regioneR::toGRanges(cnvs.df)
  GenomicRanges::mcols(cnvs.gr.final) <- GenomicRanges::mcols(cnvs.gr.final)[,  -which(names(GenomicRanges::mcols(cnvs.gr.final)) %in% c("strand","width"))]

  # Create S3 object and return
  filterParameters <- list(expected.ht.mean = expected.ht.mean, expected.dup.ht.mean1 = expected.dup.ht.mean1,
                           expected.dup.ht.mean2 = expected.dup.ht.mean2, sigmoid.c1 = sigmoid.c1, sigmoid.c2.vector = sigmoid.c2.vector,
                           dup.threshold.score = dup.threshold.score, ht.deletions.threshold = ht.deletions.threshold)
  resultsObject <- list(cnvs = cnvs.gr.final, variantsForEachCNV = variantsForEachCNV, filterParameters = filterParameters)
  class(resultsObject) <- "CNVfilteR_results"

  return(resultsObject)
}

#' plotAllCNVs
#'
#' @description
#' Plots all CNVs on chromosome ideograms
#'
#' @details
#' Plots all CNVs defined at \code{cnvs.gr} on a view of horizontal ideograms representing all chromosomes.
#'
#' @param cnvs.gr \code{GRanges} containing al CNV definitions returned by \code{filterCNVs} or \code{loadCNVcalls} functions.
#' @param genome The name of the genome. (Defaults to "hg19")
#'
#' @return invisibly returns a \code{karyoplot} object
#'
#' @examples
#' cnvs.file <- system.file("extdata", "DECoN.CNVcalls.2.csv", package = "CNVfilteR", mustWork = TRUE)
#' cnvs.gr <- loadCNVcalls(cnvs.file = cnvs.file, chr.column = "Chromosome", start.column = "Start", end.column = "End", cnv.column = "CNV.type", sample.column = "Sample")
#'
#' # Plot all CNVs
#' plotAllCNVs(cnvs.gr)
#'
#'
#' @import assertthat
#' @importFrom CopyNumberPlots plotCopyNumberCalls
#' @importFrom karyoploteR plotKaryotype
#' @importFrom graphics legend
#' @importFrom methods is
#' @export plotAllCNVs
#'
plotAllCNVs <- function(cnvs.gr, genome = "hg19"){

  assertthat::assert_that(methods::is(cnvs.gr, "GRanges"))
  assertthat::assert_that(assertthat::is.string(genome))

  # Add cn column (required by CopyNumberPlots)
  cnvs.gr <- auxAddCNcolumn(cnvs.gr)

  # Plot
  kp <- karyoploteR::plotKaryotype(plot.type=1, genome = genome)
  CopyNumberPlots::plotCopyNumberCalls(kp, cnvs.gr, r1=0.3, cn.colors = CNV_COLORS, label.cex = 0.6, loh.values = FALSE)
  graphics::legend("bottomright", legend=c("Deletion CNV", "Duplication CNV"), fill = c(CNV_COLORS[2], CNV_COLORS[4]), ncol=1, cex = 0.7)

  return(invisible(kp))
}

#' plotVariantsForCNV
#'
#' @description
#' Plots scoring model used for CNV duplications
#'
#' @param expected.ht.mean Expected heterozygous SNV/indel allele frequency
#' @param expected.dup.ht.mean1 Expected heterozygous SNV/indel allele frequency when the variant IS NOT in the same allele than the CNV duplication call
#' @param expected.dup.ht.mean2 Expected heterozygous SNV/indel allele frequency when the variant IS in the same allele than the CNV duplication call
#' @param sigmoid.c1 Sigmoid c1 parameter
#' @param sigmoid.c2.vector Vector containing sigmoid c2 parameters for the six sigmoids functions
#'
#'
#' @examples
#' # Load CNVs data
#' cnvs.file <- system.file("extdata", "DECoN.CNVcalls.csv", package = "CNVfilteR", mustWork = TRUE)
#' cnvs.gr <- loadCNVcalls(cnvs.file = cnvs.file, chr.column = "Chromosome", start.column = "Start", end.column = "End", cnv.column = "CNV.type", sample.column = "Sample")
#'
#' # Load VCFs data
#' vcf.files <- c(system.file("extdata", "variants.sample1.vcf.gz", package = "CNVfilteR", mustWork = TRUE),
#'                system.file("extdata", "variants.sample2.vcf.gz", package = "CNVfilteR", mustWork = TRUE))
#' vcfs <- loadVCFs(vcf.files, cnvs.gr = cnvs.gr)
#'
#' # Filter CNVs
#' results <- filterCNVs(cnvs.gr, vcfs)
#'
#' # Plot scoring model for duplication CNVs
#' p <- results$filterParameters
#' plotScoringModel(expected.ht.mean = p$expected.ht.mean, expected.dup.ht.mean1 = p$expected.dup.ht.mean1,
#'                   expected.dup.ht.mean2 = p$expected.dup.ht.mean2, sigmoid.c1 = p$sigmoid.c1, sigmoid.c2.vector = p$sigmoid.c2.vector)
#'
#' @return
#' nothing
#'
#'
#' @importFrom graphics legend plot lines points text abline
#' @import assertthat
#' @export plotScoringModel
#'
#'
plotScoringModel <- function(expected.ht.mean, expected.dup.ht.mean1,
                             expected.dup.ht.mean2, sigmoid.c1,
                             sigmoid.c2.vector) {


  # Check input
  assertthat::assert_that(assertthat::is.number(expected.ht.mean))
  assertthat::assert_that(assertthat::is.number(expected.dup.ht.mean1))
  assertthat::assert_that(assertthat::is.number(expected.dup.ht.mean2))
  assertthat::assert_that(assertthat::is.number(sigmoid.c1))
  assertthat::assert_that(is.numeric(sigmoid.c2.vector) && length(sigmoid.c2.vector) == 6)

  # intersections between two sigmoids curves
  sigmoid.int1 <- mean(c(expected.dup.ht.mean1, expected.ht.mean))
  sigmoid.int2 <- mean(c(expected.dup.ht.mean2, expected.ht.mean))


  # plot first part of model, (score <= 0, those that confirm CNV duplication)
  x <- seq(20, sigmoid.int1, length.out = 1000)
  y <- lapply(x, getVariantScore,  expected.ht.mean, expected.dup.ht.mean1, expected.dup.ht.mean2,
              sigmoid.c1, sigmoid.c2.vector, sigmoid.int1, sigmoid.int2)

  graphics::plot(x, y, type = "l", col = CONFIRM_COLOR,
                 xlim=c(20, 80), ylim=c(-1,1),  bty="L", lwd=2,
                 xlab = "variant allele frequency", ylab = "score",
                 main = "Scoring model for duplication CNVs",
                 panel.first = c(graphics::abline(h = 0, col = "gray"),
                                 graphics::abline(h = c(1, 0.5, -0.5, -1), lty = 2, col = "lightgray")))

  # plot second part of model, (score >= 0, those that discard CNV duplication)
  x <- seq(sigmoid.int1 + 0.00001, sigmoid.int2, length.out = 1000)
  y <- lapply(x, getVariantScore,  expected.ht.mean, expected.dup.ht.mean1, expected.dup.ht.mean2,
              sigmoid.c1, sigmoid.c2.vector, sigmoid.int1, sigmoid.int2)
  graphics::lines(x, y, type = "l", col = DISCARD_COLOR, xlab = "", ylab = "",
                  lwd=2)

  # plot third part of model, (score <= 0, those that confirm CNV duplication)
  x <- seq(sigmoid.int2 + 0.00001, 80, length.out = 1000)
  y <- lapply(x, getVariantScore,  expected.ht.mean, expected.dup.ht.mean1, expected.dup.ht.mean2,
              sigmoid.c1, sigmoid.c2.vector, sigmoid.int1, sigmoid.int2)
  graphics::lines(x, y, type = "l", col = CONFIRM_COLOR, xlab = "", ylab = "",
                  lwd=2)


  # plot expected.dup.ht.mean1-expected.ht.mean-expected.dup.ht.mean2 marks
  graphics::points((c(expected.dup.ht.mean1, expected.dup.ht.mean2)), c(-1,-1), pch=20, cex=0.7)
  graphics::text(c(expected.dup.ht.mean1, expected.dup.ht.mean2), c(-1.04,-1.04), offset = 0,
       labels=c("expected.dup.ht.mean1", "expected.dup.ht.mean2"),
       cex= 0.7, col = "#666666")
  graphics::points((c(expected.ht.mean)), c(1), pch=20, cex=0.7)
  graphics::text(c(expected.ht.mean), c(0.97), xpd=TRUE,
         labels=c("expected.ht.mean"),
         cex= 0.7, pos=3, col = "#666666")

  # plot legend
  graphics::legend("topright",
                   legend=c("Evidence for discarding a dup. CNV",
                            "Evidence for confirming a dup. CNV"),
                   border = "white", bty = "o",
                   fill = c(DISCARD_COLOR, CONFIRM_COLOR),
                   cex = 0.8, bg = "white",  box.col = "gray")
}

#' loadCNVcalls
#'
#' @description
#' Loads CNV calls from a csv/tsv file
#'
#' @details
#' Loads a csv/tsv file containing CNV calls, and transform it into a GRanges with \code{cnv} and \code{sample} metadata columns.
#'
#'
#' @param cnvs.file Path to csv/tsv file containing the CNV calls.
#' @param chr.column Which column stores the chr location of the CNV.
#' @param start.column Which column stores the start location of the CNV.
#' @param end.column Which column stores the end location of the CNV.
#' @param coord.column CNV location in the chr:start-end format. Example: "1:538001-540000". If NULL, \code{chr.column},
#' \code{start.column} and {end.column} columns will be used. (Defaults to NULL)
#' @param cnv.column Which column stores the type of CNV (deletion or duplication).
#' @param sample.column Which column stores the sample name.
#' @param sample.name Sample name for all CNVs defined in \code{cnvs.file}. If set, \code{sample.column} is ignored (Defaults to NULL)
#' @param gene.column Which columns store the gene or genes affected (optional). (Defaults to NULL)
#' @param deletion Text used in the \code{cnv.column} to represent deletion CNVs. Multiple values are also allowed, for example: c("CN0", "CN1"). (Defaults to "deletion")
#' @param duplication Text used in the \code{cnv.column} to represent duplication CNVs.  Multiple values are also allowed, for example: c("CN3", "CN4") (Defaults to "duplication")
#' @param ignore.unexpected.rows Whether to ignore the rows which CNV \code{cnv.column} value is different to \code{deletion} or \code{duplication} values (Defaults to FALSE). It is useful for processing output from callers like LUMPY or Manta (they call also events that are not CNVs)
#' @param sep Separator symbol to load the csv/tsv file. (Defaults to "\\t")
#' @param skip Number of rows that should be skipped when reading the csv/tsv file. (Defaults to 0)
#' @param genome The name of the genome. (Defaults to "hg19")
#' @param exclude.non.canonical.chrs Whether to exclude non canonical chromosomes (Defaults to TRUE)
#' @param check.names.cnvs.file Whether to check \code{cnvs.file} names or not (Defaults to FALSE).  If TRUE then column names in the \code{cnvs.file} are checked to ensure that they are syntactically valid variable names. If necessary they are adjusted (by make.names) so that they are, and also to ensure that there are no duplicates
#'
#' @return A \code{GRanges} with a range per each CNV and the metadata columns:
#' \itemize{
#'  \item \code{cnv}: type of CNV, "duplication" or "deletion"
#'  \item \code{sample}: sample name
#' }
#'
#' Returns NULL if \code{cnvs.file} has no CNVs
#'
#' @examples
#' # Load CNVs data
#' cnvs.file <- system.file("extdata", "DECoN.CNVcalls.csv", package = "CNVfilteR", mustWork = TRUE)
#' cnvs.gr <- loadCNVcalls(cnvs.file = cnvs.file, chr.column = "Chromosome", start.column = "Start", end.column = "End", cnv.column = "CNV.type", sample.column = "Sample")
#'
#'
#' @import assertthat
#' @importFrom Biostrings head
#' @importFrom regioneR toGRanges filterChromosomes
#' @importFrom utils read.csv
#'
#' @export loadCNVcalls
#'
loadCNVcalls <- function(cnvs.file, chr.column, start.column, end.column,
                         coord.column = NULL, cnv.column, sample.column,
                         sample.name = NULL, gene.column = NULL,
                         deletion = "deletion", duplication = "duplication",
                         ignore.unexpected.rows = FALSE,
                         sep = "\t", skip = 0, genome = "hg19",
                         exclude.non.canonical.chrs = TRUE,  check.names.cnvs.file=FALSE){

  # intial vars
  CNV_DF_COLUMNS <- c("chr", "start", "end", "cnv", "sample")

  # Check input
  assertthat::assert_that(assertthat::is.string(cnvs.file))
  if (is.null(coord.column)){
    assertthat::assert_that(assertthat::is.string(chr.column))
    assertthat::assert_that(assertthat::is.string(start.column))
    assertthat::assert_that(assertthat::is.string(end.column))
  } else {
    assertthat::assert_that(assertthat::is.string(coord.column))
  }
  if (is.null(sample.name)){
    assertthat::assert_that(assertthat::is.string(sample.column))
  }
  assertthat::assert_that(assertthat::is.string(cnv.column))
  assertthat::assert_that(is.character(deletion))
  assertthat::assert_that(is.character(duplication))
  assertthat::assert_that(assertthat::is.string(sep))
  assertthat::assert_that(assertthat::is.number(skip))
  assertthat::assert_that(assertthat::is.string(genome))
  assertthat::assert_that(is.logical(exclude.non.canonical.chrs))
  assertthat::assert_that(is.logical(check.names.cnvs.file))

  # Read data
  cnvs.df <- utils::read.csv(cnvs.file, sep=sep, header=TRUE,
                             check.names = check.names.cnvs.file,
                             stringsAsFactors = FALSE, skip = skip)

  if (nrow(cnvs.df) == 0){
    message(paste("Warning: ", cnvs.file," has no rows"))
    return(NULL)
  }

  # Rename and select needed columns
  colnames(cnvs.df)[which(names(cnvs.df) == cnv.column)] <- "cnv"
  if (is.null(coord.column)){
    colnames(cnvs.df)[which(names(cnvs.df) == chr.column)] <- "chr"
    colnames(cnvs.df)[which(names(cnvs.df) == start.column)] <- "start"
    colnames(cnvs.df)[which(names(cnvs.df) == end.column)] <- "end"
  } else {
    parts <- do.call(rbind, strsplit(cnvs.df$coordinates, ":|-"))
    cnvs.df$chr <- parts[,1]
    cnvs.df$start <- parts[,2]
    cnvs.df$end <- parts[,3]
  }

  # Set sample name column
  if (is.null(sample.name)){
    colnames(cnvs.df)[which(names(cnvs.df) == sample.column)] <- "sample"
  } else {
    cnvs.df$sample <- sample.name
  }

  # Force sample to be character: it will avoid problems when in future steps
  cnvs.df$sample <- as.character(cnvs.df$sample)

  # Assert CNV type values are correct
  cnvValuesCheck <- unique(cnvs.df$cnv) %in%  c(deletion, duplication)
  if(!identical(unique(cnvValuesCheck), TRUE)) {
    if (!ignore.unexpected.rows){
      stop(paste0("Values found in ", cnv.column, " column are ",
                 toString(Biostrings::head(unique(cnvs.df$cnv))), " but expected values are only '",
                 toString(c(deletion, duplication)),
                 "'. Please, use the duplication and deletion parameters to select the expected values for the ",
                 cnv.column ," column, or set ignore.unexpected.rows parameter to TRUE"))
    }
  }


  # depending on gene.column provided or not...
  if (assertthat::is.string(gene.column)){
    colnames(cnvs.df)[which(names(cnvs.df) == gene.column)] <- "gene"
    CNV_DF_COLUMNS <- c(CNV_DF_COLUMNS, "gene")
  }

  # Select only desired columns
  cnvs.df <- cnvs.df[, CNV_DF_COLUMNS]

  # reassign deletion / duplication text values
  cnvs.df[cnvs.df$cnv %in% deletion, "cnv"] <- "deletion"
  cnvs.df[cnvs.df$cnv %in% duplication, "cnv"] <- "duplication"

  # Discard those rows with a CNV type different to the expected ones
  cnvs.df <- cnvs.df[cnvs.df$cnv %in% c("deletion", "duplication"),]

  # Transform to GRanges
  cnvs.gr <- regioneR::toGRanges(cnvs.df, genome = genome)

  # Exclude non cannonical chromosomes to avoid conflicts when comparing later with GRanges with different non canonical chromosomes
  if (exclude.non.canonical.chrs){
    cnvs.gr <- regioneR::filterChromosomes(cnvs.gr, organism = genome)
  }


  return(cnvs.gr)
}

#' plotVariantsForCNV
#'
#' @description
#' Plots a CNV with all the variants in it
#'
#' @param cnvfilter.results S3 object returned by \code{filterCNVs} function
#' @param cnv.id CNV id for which to plot variants
#' @param points.cex Points cex (size). (Defaults to 1)
#' @param points.pch Points pch (symbol). (Defaults to 19)
#' @param legend.x.pos Legend x position. (Defaults to 0.08)
#' @param legend.y.pos Legend y position. (Defaults to 0.25)
#' @param legend.cex Legend cex. (Defaults to 0.8)
#' @param legend.text.width Legend text width (Defaults to NULL)
#' @param legend.show Whether to show the legend (Defaults to TRUE)
#' @param karyotype.cex karyotype cex: affects top title and chromosome text (at bottom). (Defaults to 1)
#' @param cnv.label.cex "CNV" text cex. (Defaults to 1)
#' @param x.axis.bases.cex X-axis bases position cex. (Defaults to 0.7)
#' @param x.axis.bases.digits X-axis bases position number of digits. (Defaults to 5)
#' @param y.axis.title.cex Y-axis title cex. (Defaults to 0.8)
#' @param y.axis.label.cex Y-axis labels cex. (Defaults to 0.8)
#' @param cnv.zoom.margin If TRUE, the zoom leaves an small margin at both sides of the CNV. False otherwise. (Defaults to TRUE)
#'
#' @return invisibly returns a \code{karyoplot} object
#'
#' @examples
#' # Load CNVs data
#' cnvs.file <- system.file("extdata", "DECoN.CNVcalls.csv", package = "CNVfilteR", mustWork = TRUE)
#' cnvs.gr <- loadCNVcalls(cnvs.file = cnvs.file, chr.column = "Chromosome", start.column = "Start", end.column = "End", cnv.column = "CNV.type", sample.column = "Sample")
#'
#' # Load VCFs data
#' vcf.files <- c(system.file("extdata", "variants.sample1.vcf.gz", package = "CNVfilteR", mustWork = TRUE),
#'                system.file("extdata", "variants.sample2.vcf.gz", package = "CNVfilteR", mustWork = TRUE))
#' vcfs <- loadVCFs(vcf.files, cnvs.gr = cnvs.gr)
#'
#' # Filter CNVs
#' results <- filterCNVs(cnvs.gr, vcfs)
#'
#' # Check CNVs that can be filtered out
#' as.data.frame(results$cnvs[results$cnvs$filter == TRUE])
#'
#' # Plot one of them
#' plotVariantsForCNV(results, "3")
#'
#'
#' @importFrom CopyNumberPlots plotCopyNumberCalls
#' @import karyoploteR
#' @importFrom graphics legend
#' @importFrom GenomicRanges width start end
#' @importFrom methods is
#' @import assertthat
#' @export plotVariantsForCNV
#'
plotVariantsForCNV <- function(cnvfilter.results, cnv.id,
                               points.cex = 1, points.pch = 19,
                               legend.x.pos = 0.08, legend.y.pos = 0.25, legend.cex = 0.8,
                               legend.text.width = NULL, legend.show = TRUE,
                               karyotype.cex = 1, cnv.label.cex = 1,
                               x.axis.bases.cex = 0.7, x.axis.bases.digits = 5,
                               y.axis.title.cex = 0.8, y.axis.label.cex = 0.8,
                               cnv.zoom.margin = TRUE) {

  # Check input
  assertthat::assert_that(methods::is(cnvfilter.results, "CNVfilteR_results"))
  assertthat::assert_that(assertthat::is.string(cnv.id))
  assertthat::assert_that(assertthat::is.number(points.cex))
  assertthat::assert_that(assertthat::is.number(points.pch))
  assertthat::assert_that(is.logical(cnv.zoom.margin))
  assertthat::assert_that(is.null(legend.text.width) || is.numeric(legend.text.width))
  assertthat::assert_that(is.logical(legend.show))

  # Get filter params values for later use
  params <- cnvfilter.results$filterParameters

  # Add cn column (required by CopyNumberPlots)
  cnvs.gr <- auxAddCNcolumn(cnvfilter.results$cnvs)
  cnv <- cnvs.gr[cnvs.gr$cnv.id == cnv.id,]

  # Build main title
  title <-  paste0(cnv$cnv, " at ", toString(cnv))
  if (cnv$filter == "TRUE"){
    if (cnv$cnv == "deletion") {
      title <- paste0(title, ", it can be filtered out")
    } else if (cnv$cnv == "duplication") {
      title <- paste0(title, ", it can be filtered out with a score of ", round(as.numeric(cnv$score), 4))
    }
  }

  # Prepare vars
  r0 = 0.1; r1=0.95;
  duphtmean1 <- params$expected.dup.ht.mean1 / 100.0
  duphtmean2 <- params$expected.dup.ht.mean2 / 100.0
  htmean <- params$expected.ht.mean / 100.0
  zoomGR <- cnv
  if (cnv.zoom.margin) {
    GenomicRanges::start(zoomGR) <- GenomicRanges::start(zoomGR) - GenomicRanges::width(cnv) * 0.1
    GenomicRanges::end(zoomGR) <- GenomicRanges::end(zoomGR) + GenomicRanges::width(cnv) * 0.1
  }

  ## Plot ##

  # Plot different elements
  pp <- karyoploteR::getDefaultPlotParams(4)
  pp$leftmargin <- 0.15
  pp$ideogramheight <- 2
  pp$topmargin <- 40
  kp <- karyoploteR::plotKaryotype(zoom = zoomGR, plot.type = 4, cex = karyotype.cex,
                                   plot.params = pp, main = title)
  karyoploteR::kpAddBaseNumbers(kp, tick.dist = GenomicRanges::width(cnv) / 5.0,
                                cex = x.axis.bases.cex, digits = x.axis.bases.digits,
                                add.units = TRUE)
  CopyNumberPlots::plotCopyNumberCalls(kp, cnv, cn.colors = CNV_COLORS, r0=0, loh.values = FALSE,
                                       label.cex = cnv.label.cex,
                                       r1=0.03, labels = "CNV")
  karyoploteR::kpAddLabels(kp, r0 = r0, r1 = r1, labels = c("variant allele frequency"),
                           srt = 90, pos = 3, cex = y.axis.title.cex, label.margin = 0.1)

  # Add guide lines depending on CNV type
  if (cnv$cnv == "deletion") {
    karyoploteR::kpAxis(kp, ymin=0, ymax=1, r0=r0, r1=r1, col="gray50",
                        cex = y.axis.label.cex,
                        labels = c("0", htmean, "1"), tick.pos = c(0, htmean, 1))
    karyoploteR::kpAbline(kp, h=c(htmean), col="gray80", ymin=0, ymax=1, r0=r0,
                          r1=r1, lty=2, lwd = 1)
  } else if (cnv$cnv == "duplication"){
    karyoploteR::kpAxis(kp, ymin=0, ymax=1, r0=r0, r1=r1, col="gray50",
                        cex = y.axis.label.cex,
                        labels = c("0", duphtmean1, htmean, duphtmean2, "1"),
                        tick.pos = c(0, duphtmean1, htmean, duphtmean2, 1))
    karyoploteR::kpAbline(kp, h=c(duphtmean1, htmean, duphtmean2), col="gray80",
                          ymin=0, ymax=1, r0=r0, r1=r1, lty=2, lwd = 1)
  }


  # Draw legend
  if (legend.show){
    graphics::legend(x=legend.x.pos, y=legend.y.pos, legend=c("Discard CNV", "Confirm CNV", "Neutral", "CNV deletion", "CNV duplication"),
          pch = c(points.pch, points.pch, points.pch, NA, NA), pt.cex=1, bg = "white",  box.col = "gray",
          col = c(DISCARD_COLOR, CONFIRM_COLOR, NEUTRAL_COLOR, NA, NA),
          border = "white", cex = legend.cex, text.width = legend.text.width,
          fill = c(NA, NA, NA, CNV_COLORS[2], CNV_COLORS[4]), ncol=2,
          bty="l")
  }

  # Load variants for desired cnv
  vars <- cnvfilter.results$variantsForEachCNV[[cnv.id]]
  if (!is.null(vars)){

    # Move freq values to the 0-1 interval
    vars$alt.freq <- vars$alt.freq / 100.0

    # Add points depending o CNV type
    if (cnv$cnv == "deletion") {
      v_sub <- vars[vars$type=="ht",]
      karyoploteR::kpPoints(kp, chr = as.character(v_sub$seqnames), x=v_sub$start, y=v_sub$alt.freq, col=DISCARD_COLOR, r0 = r0, r1=r1, cex=points.cex, pch=points.pch)
      v_sub <- vars[vars$type=="hm",]
      karyoploteR::kpPoints(kp, chr = as.character(v_sub$seqnames), x=v_sub$start, y=v_sub$alt.freq, col=NEUTRAL_COLOR, r0 = r0, r1=r1, cex=points.cex, pch=points.pch)
    } else if (cnv$cnv == "duplication") {
      v_sub <- vars[vars$score == 0,]
      karyoploteR::kpPoints(kp, chr = as.character(v_sub$seqnames), x=v_sub$start, y=v_sub$alt.freq, col=NEUTRAL_COLOR, r0 = r0, r1=r1, cex=points.cex, pch=points.pch)
      v_sub <- vars[vars$score > 0,]
      karyoploteR::kpPoints(kp, chr = as.character(v_sub$seqnames), x=v_sub$start, y=v_sub$alt.freq, col=DISCARD_COLOR, r0 = r0, r1=r1, cex=points.cex, pch=points.pch)
      v_sub <- vars[vars$score < 0,]
      karyoploteR::kpPoints(kp, chr = as.character(v_sub$seqnames), x=v_sub$start, y=v_sub$alt.freq, col=CONFIRM_COLOR, r0 = r0, r1=r1, cex=points.cex, pch=points.pch)
    }
  }


  return(invisible(kp))
}

#' loadSNPsFromVCF
#'
#' @description
#' Loads SNPs (SNVs/indels) from a VCF file
#'
#' @details
#' Given a VCF file path, the function recognizes the variant caller source to decide which fields should be used to calculate
#' ref/alt support and allelic frequency (see \code{return}). Current supported variant callers are VarScan2, Strelka/Strelka2, freebayes,
#' HaplotypeCaller, UnifiedGenotyper and Torrent Variant Caller.
#'
#' Optionally, the fields where the data is stored can be manually set by using the parameters \code{ref.support.field},
#' \code{alt.support.field} and \code{list.support.field}
#'
#' Requirement: a TabixFile (.tbi) should exists in the same directory of the VCF file.
#'
#' @param vcf.file VCF file path
#' @param vcf.source VCF source, i.e., the variant caller used to generate the VCF file. If set, the function will not try to recognize the source. (Defaults to NULL)
#' @param ref.support.field Reference allele depth field. (Defaults to NULL)
#' @param alt.support.field Alternative allele depth field. (Defaults to NULL)
#' @param list.support.field Allele support field in a list format: reference allele, alternative allele. (Defaults to NULL)
#' @param regions.to.filter The regions to which limit the VCF import. It can be used to speed up the import process. (Defaults to NULL)
#' @param genome The name of the genome (Defaults to "hg19")
#' @param exclude.non.canonical.chrs Whether to exclude non canonical chromosomes (Defaults to TRUE)
#' @param verbose Whether to show information messages. (Defaults to TRUE)
#'
#' @return A list where names are sample names, and values are \code{GRanges} objects containing the variants for each sample, including the following metadata columns:
#' \itemize{
#'  \item \code{ref.support}: Reference allele depth field
#'  \item \code{alt.support}: Alternative allele depth field
#'  \item \code{alt.freq}: allelic frequency
#'  \item \code{total.depth}: total depth
#' }
#'
#' @examples
#' vcf.file <- system.file("extdata", "variants.sample1.vcf.gz", package = "CNVfilteR", mustWork = TRUE)
#' vcf <- loadSNPsFromVCF(vcf.file)
#'
#' @import assertthat
#' @import VariantAnnotation
#' @importFrom GenomeInfoDb seqlevelsStyle seqlevels
#' @importFrom regioneR toGRanges filterChromosomes
#' @importFrom Rsamtools TabixFile headerTabix
#' @importFrom methods is
#' @importFrom IRanges reduce
#' @importFrom GenomicRanges mcols seqnames
#' @importFrom SummarizedExperiment rowRanges
#' @export loadSNPsFromVCF
#'
loadSNPsFromVCF <- function(vcf.file, vcf.source = NULL, ref.support.field = NULL, alt.support.field = NULL,
                            list.support.field = NULL, regions.to.filter = NULL, genome = "hg19",
                            exclude.non.canonical.chrs = TRUE, verbose = TRUE) {

  # Check input
  assertthat::assert_that(assertthat::is.string(vcf.file))
  assertthat::assert_that(assertthat::is.string(vcf.source) || is.null(vcf.source))
  assertthat::assert_that(assertthat::is.string(ref.support.field) || is.null(ref.support.field))
  assertthat::assert_that(assertthat::is.string(alt.support.field) || is.null(alt.support.field))
  assertthat::assert_that(assertthat::is.string(list.support.field) || is.null(list.support.field))
  assertthat::assert_that(methods::is(regions.to.filter, "GRanges") || is.null(regions.to.filter))
  assertthat::assert_that(assertthat::is.string(genome))
  assertthat::assert_that(is.logical(exclude.non.canonical.chrs))
  assertthat::assert_that(is.logical(verbose))

  if (verbose) message("Scanning file ", vcf.file, "...")

  if(!is.null(regions.to.filter))
    regions.to.filter <- tryCatch(regioneR::toGRanges(regions.to.filter), error = function(e){stop("regions.to.filter must be in a valid format accepted by toGRanges.\n ", e)})


  ##  GET VCF SOURCE  ##

  # Get VCF source
  vcf.source <- auxGetVcfSource(vcf.source, vcf.file)

  # Check if vcf source was finally recognized
  supported.tools <- c("VarScan2", "strelka", "freeBayes", "HaplotypeCaller", "UnifiedGenotyper", "Torrent Variant Caller")
  msg <- ""
  if (!vcf.source %in% supported.tools){
    if ( (is.null(ref.support.field) | is.null(alt.support.field)) & (is.null(list.support.field)) )  {
      stop(paste("VCF source was not recognized, and ref.support.field/alt.support.field/list.support.field were not provided. Expected options are:", paste(supported.tools, collapse = " ")))
    } else {
      if (!is.null(list.support.field)) {
        msg <- paste("VCF source", vcf.source ,"is not supported, but list.support.field was provided. ")
      } else {
        msg <- paste("VCF source", vcf.source ,"is not supported, but ref.support.field/alt.support.field were provided. ")
      }
    }
  } else {
    msg <- paste(vcf.source, "was found as source in the VCF metadata,")
  }


  ##  GET VCF FIELDS  ##

  # Detect format: recognise fields where allelic depth and frequency are stored
  support.field.is.list <- FALSE
  ref.and.forward.fields <- FALSE

  if (vcf.source == "VarScan2") {
    if (is.null(ref.support.field)) ref.support.field <- "RD"
    if (is.null(alt.support.field)) alt.support.field <- "AD"
    msg <- paste(msg, ref.support.field, "will be used as ref allele depth field,", alt.support.field, "will be used as alt allele depth field.")
  } else if (vcf.source == "Torrent Variant Caller") {
    if (is.null(ref.support.field)) ref.support.field <- "RO"
    if (is.null(alt.support.field)) alt.support.field <- "AO"
    msg <- paste(msg, ref.support.field, "will be used as ref allele depth field,", alt.support.field, "will be used as alt allele depth field.")
  } else if (vcf.source %in% c("strelka", "freeBayes", "HaplotypeCaller", "UnifiedGenotyper"))  {
    if (is.null(list.support.field))
      list.support.field <- "AD"
    msg <- paste(msg, list.support.field, "will be used as allele support field in a list format: ref allele, alt allele.")
  }

  # Set support.field.is.list
  if (!is.null(list.support.field)){
    support.field.is.list <- TRUE
  }

  # set genoField
  if (is.null(ref.support.field)){
    genoField <- c("GT", list.support.field)
  } else {
    genoField <- c("GT", ref.support.field, alt.support.field)
  }

  if (verbose) message(msg)


  ##  PROCESS VCF VARIANTS  ##

  # Get variants according to detected desired regions.to.filter
  if (!is.null(regions.to.filter)) {

    # reduce (join) all regions to avoid duplicated positions when using which command
    regions.to.filter <- IRanges::reduce(regions.to.filter)

    # Get seqnames from vcf
    availableSeqs <- Rsamtools::headerTabix(vcf.file)$seqnames

    # Convert regions.to.filter to Ensembl / UCSC chr style if necessary
    if (all(grepl("chr", seqlevels(regions.to.filter))) & all(!grepl("chr", availableSeqs))){
      GenomeInfoDb::seqlevelsStyle(regions.to.filter) <- "Ensembl"
    } else if (all(!grepl("chr", seqlevels(regions.to.filter))) & all(grepl("chr", availableSeqs))){
      GenomeInfoDb::seqlevelsStyle(regions.to.filter) <- "UCSC"
    }

    # filter regions.to.filter by available seqnames to prevent an error when calling readVcf
    regions.to.filter <- regions.to.filter[as.character(GenomicRanges::seqnames(regions.to.filter)) %in% availableSeqs]

    # create ScanVcfParam
    scan.vcf.param <- VariantAnnotation::ScanVcfParam(info=NA, geno = genoField, which = regions.to.filter)

  } else {
    scan.vcf.param <- VariantAnnotation::ScanVcfParam(info=NA, geno = genoField)
  }


  # load variants
  vars <- VariantAnnotation::readVcf(file=Rsamtools::TabixFile(vcf.file), genome = genome, param = scan.vcf.param)
  if (length(vars) > 0) {
    GenomeInfoDb::seqlevelsStyle(GenomeInfoDb::seqlevels(SummarizedExperiment::rowRanges(vars))) <- "UCSC"
  }

  # process each sample
  samples <- colnames(vars)
  res <- list()
  for(s in samples) {

    v <- vars[,s]

    # Filter: only variants with GT denoting that the variant was found
    ids.to.select <- sapply(VariantAnnotation::geno(v)[["GT"]],
                            function(gt) gt %in% c("0/1", "0|1", "1/1", "1|1"))
    if (length(ids.to.select) > 0) {
      v <- v[ids.to.select]
    }


    if (support.field.is.list) {

      # Get alt depth
      depths.list <- VariantAnnotation::geno(v)[[list.support.field]]

      # process it expecting 4 or 2 items
      if (ref.and.forward.fields) {
        # Discard those variants with unexpected number of ref/alt values
        ids.to.select <- sapply(depths.list, function(i) length(i) == 4)
        v <- v[ids.to.select]
        depths.list <- depths.list[ids.to.select]

        # Get depths
        depths.ref1 <- unlist(lapply(depths.list, "[", 1))
        depths.ref2 <- unlist(lapply(depths.list, "[", 2))
        depths.alt3 <- unlist(lapply(depths.list, "[", 3))
        depths.alt4 <- unlist(lapply(depths.list, "[", 4))
        depths.ref <- depths.ref1 + depths.ref2
        depths.alt <- depths.alt3 + depths.alt4
      } else {

        # Discard those variants with unexpected number of ref/alt values
        ids.to.select <- sapply(depths.list, function(i) length(i) == 2)
        if (length(ids.to.select) > 0) {
          v <- v[ids.to.select]
          depths.list <- depths.list[ids.to.select]
        }

        # Get depths
        depths.ref <- unlist(lapply(depths.list, "[", 1))
        depths.alt <- unlist(lapply(depths.list, "[", 2))
      }

    } else {
      depths.alt <- unlist(VariantAnnotation::geno(v)[[alt.support.field]])
      depths.ref <- unlist(VariantAnnotation::geno(v)[[ref.support.field]])
    }

    # calculate allelic freq
    freqs.alt <- round(depths.alt / (depths.alt + depths.ref) * 100, 4)
    freqs.alt[is.nan(freqs.alt)] <- 0

    # calculate total depth
    total.depth <- depths.alt + depths.ref

    #Build the GRanges
    ref <- VariantAnnotation::ref(v)
    alt <- unlist(VariantAnnotation::alt(v))
    v <- SummarizedExperiment::rowRanges(v)
    mdata <- data.frame(ref = ref, alt = alt, ref.support = as.vector(depths.ref), alt.support = as.vector(depths.alt),
                        alt.freq = as.vector(freqs.alt), total.depth = as.vector(total.depth))
    GenomicRanges::mcols(v) <- mdata

    # Exclude non cannonical chromosomes to avoid conflicts when comparing later with GRanges with different non canonical chromosomes
    if (exclude.non.canonical.chrs){
      v <- regioneR::filterChromosomes(v, organism = genome)
    }

    # save variants
    res[[s]] <- v
  }

  return(res)
}


#' auxGetVcfSource
#'
#' @description
#' Obtains VCF source from a given VCF file path. Auxiliar function used by \code{loadSNPsFromVCF}.
#'
#' @param vcf.source VCF source. Leave NULL to allow the function to recognize it. Otherwise, the function will not try to recognize the source. (Defaults to NULL)
#' @param vcf.file VCF file path
#'
#' @return VCF source
#'
#'
#' @import assertthat
#' @import VariantAnnotation
#' @importFrom utils str
#'
auxGetVcfSource <- function(vcf.source = NULL, vcf.file){

  # Call scanVcfHeader() but controlling if knwon error occurs
  tryCatch(
    {
      vcf.header <- VariantAnnotation::scanVcfHeader(vcf.file)
    },
    error = function(cond){
      if (cond$message == "subscript out of bounds"){
        stop(paste0("There was an error when calling scanVcfHeader() with vcf.file=",
                   vcf.file, ": \"", cond$message,
                   "\". It's probably due to a VCF file with no variants."))
      } else {
        stop(cond$message)
      }
    }
  )

  vcf.header.meta <- VariantAnnotation::meta(vcf.header)

  # Get VCF source if necessary
  if (is.null(vcf.source)) {
    vcf.source <- vcf.header.meta$source[,1]
    if (grepl("Torrent Variant Caller", vcf.source)){
      vcf.source <- "Torrent Variant Caller"
    }
    if (!is.null(vcf.source) && is.na(vcf.source))
      vcf.source <- NULL
  }

  # if not found, look at alternative header fields
  if (is.null(vcf.source)){

    # Try to find GATK caller in raw header
    vcf.lines <- readLines(vcf.file)
    for (l in vcf.lines){
      if (grepl("GATKCommandLine.HaplotypeCaller", l)) {
        vcf.source <- "HaplotypeCaller"
        break
      } else if (grepl("GATKCommandLine.UnifiedGenotyper", l)) {
        vcf.source <- "UnifiedGenotyper"
        break
      } else if (grepl("#CHROM", l))
        break
    }
  }

  # other vcf checks
  if (is.null(vcf.source)) {
    stop("No VCF source was found at VCF file and not VCF source was defined as input param.")
  } else if (grepl("freeBayes", vcf.source)){
    vcf.source <- "freeBayes"
  }

  return(vcf.source)
}

# Constants: color schema used for plotting CNVs with CopyNumberPlots package
CNV_COLORS <- c("0" = "black", "#A5C94D", "gray", "#C2506A","black","black","black","black")
CONFIRM_COLOR <- "#3179B1"
DISCARD_COLOR <- "#F28834"
NEUTRAL_COLOR <- "#555555"

#' auxAddCNcolumn
#'
#' @description
#' Adds a 'cn' column to the \code{cnvs.gr} data.frame or GRanges.
#'
#' @details
#' For each row, \code{cn} column is filled with 1 if \code{cnv} is "deletion", 3 if \code{cnv} is "duplication"
#'
#' @param cnvs.gr \code{data.frame or GRanges} containing the column 'cnv' with "deletion" or "duplication" as values
#'
#'
#' @return
#' input \code{cnvs.gr} with the new column 'cn'
#'
#' @import assertthat
#' @importFrom methods is
#'
auxAddCNcolumn <- function(cnvs.gr){

  assertthat::assert_that(methods::is(cnvs.gr, "GRanges") || is.data.frame(cnvs.gr))

  cnvs.gr$cn <- 0
  if (length(cnvs.gr[cnvs.gr$cnv == "deletion"]) > 0) {
    cnvs.gr[cnvs.gr$cnv == "deletion"]$cn <- 1
  }
  if (length(cnvs.gr[cnvs.gr$cnv == "duplication"]) > 0){
    cnvs.gr[cnvs.gr$cnv == "duplication"]$cn <- 3
  }
  return (cnvs.gr)
}

#' loadVCFs
#'
#' @description
#' Loads VCFs files
#'
#' @details
#' Loads VCF files and computes alt allele frequency for each variant. It uses
#' \code{\link{loadSNPsFromVCF}} function load the data and identify the
#' correct VCF format for allele frequency computation.
#'
#' If sample.names is not provided, the sample names included in the VCF itself
#' will be used. Both single-sample and multi-sample VCFs are accepted, but when
#' multi-sample VCFs are used, sample.names parameter must be NULL.
#'
#' If vcf is not compressed with bgzip, the function compresses it and generates
#' the .gz file. If .tbi file does not exist for a given VCF file, the function
#' also generates it. All files are generated in a temporary folder.
#'
#' @note Important: Compressed VCF must be compressed with
#' [bgzip ("block gzip") from Samtools htslib](http://www.htslib.org/doc/bgzip.html)
#' and not using the standard Gzip utility.
#'
#' @param vcf.files vector of VCFs paths. Both .vcf and .vcf.gz extensions are allowed.
#' @param sample.names Sample names vector containing sample names for each \code{vcf.files}. If NULL, sample name will be obtained from the VCF sample column.  (Defaults to NULL)
#' @param cnvs.gr \code{GRanges} object containg CNV calls. Call \code{loadCNVcalls} to obtain it. Only those variants in regions affected by CNVs will be loaded to speed up the load.
#' @param min.total.depth Minimum total depth. Variants under this value will be excluded. (Defaults to 10)
#' @param regions.to.exclude A \code{GRanges} object defining the regions for which the variants should be excluded.
#' Useful for defining known difficult regions like pseudogenes where the allele frequency is not trustable. (Defaults to NULL)
#' @param vcf.source VCF source, i.e., the variant caller used to generate the VCF file. If set, the \code{loadSNPsFromVCF} function will not try to recognize the source. (Defaults to NULL)
#' @param ref.support.field Reference allele depth field. (Defaults to NULL)
#' @param alt.support.field Alternative allele depth field. (Defaults to NULL)
#' @param list.support.field Allele support field in a list format: reference allele, alternative allele. (Defaults to NULL)
#' @param homozygous.range Homozygous range. Variants not in the homozygous/heterozygous intervals will be excluded. (Defaults to \code{c(90, 100)})
#' @param heterozygous.range Heterozygous range. Variants not in the homozygous/heterozygous intervals will be excluded. (Defaults to \code{c(28, 72)})
#' @param exclude.indels Whether to exclude indels when loading the variants. TRUE is the recommended value given that indels frequency varies in a different way than SNVs. (Defaults to TRUE)
#' @param genome The name of the genome. (Defaults to "hg19")
#' @param exclude.non.canonical.chrs Whether to exclude non canonical chromosomes (Defaults to TRUE)
#' @param verbose Whether to show information messages. (Defaults to TRUE)
#'
#' @return A list where names are the sample names, and values are the \code{GRanges} objects for each sample.
#'
#' @examples
#' # Load CNVs data (required by loadVCFs to speed up the load process)
#' cnvs.file <- system.file("extdata", "DECoN.CNVcalls.csv", package = "CNVfilteR", mustWork = TRUE)
#' cnvs.gr <- loadCNVcalls(cnvs.file = cnvs.file, chr.column = "Chromosome", start.column = "Start", end.column = "End", cnv.column = "CNV.type", sample.column = "Sample")
#'
#' # Load VCFs data
#' vcf.files <- c(system.file("extdata", "variants.sample1.vcf.gz", package = "CNVfilteR", mustWork = TRUE),
#'                system.file("extdata", "variants.sample2.vcf.gz", package = "CNVfilteR", mustWork = TRUE))
#' vcfs <- loadVCFs(vcf.files, cnvs.gr = cnvs.gr)
#'
#'
#' @import assertthat
#' @importFrom IRanges subsetByOverlaps
#' @importFrom GenomicRanges mcols
#' @importFrom Biostrings width
#' @importFrom methods is
#' @importFrom Rsamtools indexTabix bgzip
#' @export loadVCFs
#'
loadVCFs <- function(vcf.files, sample.names = NULL, cnvs.gr,
                     min.total.depth = 10, regions.to.exclude = NULL, vcf.source = NULL,
                     ref.support.field = NULL, alt.support.field = NULL, list.support.field = NULL,
                     homozygous.range = c(90,100), heterozygous.range = c(28,72), exclude.indels = TRUE,
                     genome = "hg19", exclude.non.canonical.chrs = TRUE, verbose = TRUE) {

  # Check input
  assertthat::assert_that(is.character(vcf.files))
  assertthat::assert_that(is.null(sample.names) || (is.character(sample.names) & length(vcf.files) == length(sample.names)) )
  assertthat::assert_that(methods::is(cnvs.gr, "GRanges"))
  assertthat::assert_that(assertthat::is.number(min.total.depth))
  assertthat::assert_that(methods::is(regions.to.exclude, "GRanges") || is.null(regions.to.exclude))
  assertthat::assert_that(assertthat::is.string(vcf.source) || is.null(vcf.source))
  assertthat::assert_that(assertthat::is.string(ref.support.field) || is.null(ref.support.field))
  assertthat::assert_that(assertthat::is.string(alt.support.field) || is.null(alt.support.field))
  assertthat::assert_that(assertthat::is.string(list.support.field) || is.null(list.support.field))
  assertthat::assert_that(is.numeric(homozygous.range) && length(homozygous.range) == 2)
  assertthat::assert_that(homozygous.range[1] < homozygous.range[2])
  assertthat::assert_that(heterozygous.range[1] < heterozygous.range[2])
  assertthat::assert_that(heterozygous.range[2] < homozygous.range[1])
  assertthat::assert_that(is.numeric(heterozygous.range) && length(heterozygous.range) == 2)
  assertthat::assert_that(is.logical(exclude.indels))
  assertthat::assert_that(assertthat::is.string(genome))
  assertthat::assert_that(is.logical(exclude.non.canonical.chrs))
  assertthat::assert_that(is.logical(verbose))


  # Decide where sample names are obtained from
  sample.names.mode <- NULL
  if(is.null(sample.names)){
    sample.names.mode <-  "readFromVCF"
  } else if (is.vector(sample.names)){
    sample.names.mode <-  "oneSamplePerVCF"
  }

  # Load and filter each VCF
  results <- list()
  for (vcfFile in vcf.files){

    originalVcfFile <- vcfFile
    if (!endsWith(vcfFile, ".gz"))
      vcfFile <- paste0(vcfFile, ".gz")

    # create .gz or .tbi if necessary (in temp dir)
    tbiFile <- paste0(vcfFile, ".tbi")
    if (!file.exists(vcfFile) | !file.exists(tbiFile)) {

      # Copy file to temp
      tempFolder <- tempdir()
      file.copy(originalVcfFile, file.path(tempFolder, basename(originalVcfFile)))
      vcfFile <- file.path(tempFolder, basename(vcfFile))

      # compress
      Rsamtools::bgzip(originalVcfFile, vcfFile, overwrite = TRUE)  # generate .gz in a temp path

      # create tabix file
      tbiFile <- paste0(vcfFile, ".tbi")
      Rsamtools::indexTabix(vcfFile, "vcf")
    }

    # Read data
    variantsList <- loadSNPsFromVCF(vcf.file = vcfFile, verbose = verbose, vcf.source = vcf.source, ref.support.field = ref.support.field,
                                    alt.support.field = alt.support.field, list.support.field = list.support.field, regions.to.filter = cnvs.gr,
                                    genome = genome, exclude.non.canonical.chrs = exclude.non.canonical.chrs)

    # Stop if found > 1 samples in a vcf file and sample.names vector was given
    samplesFoundInVCF <- names(variantsList)
    nSamples <- length(samplesFoundInVCF)
    if (nSamples > 1 & sample.names.mode == "oneSamplePerVCF"){
      stop("More than one sample was found in", vcfFile, "Please, use sample.names parameter only when working with VCF files with one sample column.")
    }

    # process variants depending on mode
    if (sample.names.mode == "readFromVCF"){

      for (sampleName in samplesFoundInVCF){
        vars <-  variantsList[[sampleName]]
        sampleCNVsGR <- cnvs.gr[cnvs.gr$sample == sampleName, ]
        results[[sampleName]] <- auxProcessVariants(vars, sampleCNVsGR, heterozygous.range, homozygous.range, min.total.depth, exclude.indels, regions.to.exclude)
      }

    } else {  # oneSamplePerVCF mode
      vars <- variantsList[[1]]
      sampleName <- sample.names[length(results) + 1]
      sampleCNVsGR <- cnvs.gr[cnvs.gr$sample == sampleName, ]
      results[[sampleName]] <- auxProcessVariants(vars, sampleCNVsGR, heterozygous.range, homozygous.range, min.total.depth, exclude.indels, regions.to.exclude)
    }


  }

  return(results)
}



#' auxProcessVariants
#'
#' @description
#' Auxiliar function called by \code{loadVCFs} to process variants
#'
#' @param vars \code{GRanges} object containing variants for a certain sample.
#' @param cnvGR \code{GRanges} object containg CNV calls for a certain sample.
#' @param heterozygous.range Heterozygous range. Variants not in the homozygous/heterozygous intervals will be excluded.
#' @param homozygous.range Homozygous range. Variants not in the homozygous/heterozygous intervals will be excluded.
#' @param min.total.depth Minimum total depth. Variants under this value will be excluded.
#' @param exclude.indels Whether to exclude indels when loading the variants. TRUE is the recommended value given that indels frequency varies in a different way than SNVs.
#' @param regions.to.exclude A \code{GRanges} object defining the regions for which the variants should be excluded.
#'
#' @return Processed \code{vars}
#'
#' @import assertthat
#' @importFrom IRanges subsetByOverlaps
#' @importFrom GenomicRanges mcols
#'
auxProcessVariants <- function(vars, cnvGR, heterozygous.range, homozygous.range, min.total.depth, exclude.indels, regions.to.exclude){

  # Exclude variants overlaping regions.to.exclude
  if (!is.null(regions.to.exclude)) {
    vars <- IRanges::subsetByOverlaps(vars, regions.to.exclude,  type = "any", invert = TRUE)
  }

  # Subset: only variants on CNV regions
  vars <- IRanges::subsetByOverlaps(vars, cnvGR, type = "any")

  # Process variants
  if (length(vars) > 0){
    mcolumns <- GenomicRanges::mcols(vars)
    mcolumns$indel <- Biostrings::width(mcolumns$ref) > 1 | Biostrings::width(mcolumns$alt) > 1
    mcolumns$type <- ""
    mcolumns <- as.data.frame(mcolumns)  # to speed up
    mcolumns[mcolumns$alt.freq >= heterozygous.range[1] & mcolumns$alt.freq <= heterozygous.range[2], "type"] <- "ht"
    mcolumns[mcolumns$alt.freq >= homozygous.range[1] & mcolumns$alt.freq <= homozygous.range[2], "type"] <- "hm"

    # set meta-columns
    GenomicRanges::mcols(vars) <- as.data.frame(mcolumns)

    # retag as overlap_indel those SNV variants overlapped by an indel. Those variant will no be used in analysis
    snvs <- vars[!vars$indel,]
    indels <- vars[vars$indel,]
    overlapped <- IRanges::subsetByOverlaps(snvs, indels)
    indexes <- which(row.names(GenomicRanges::mcols(vars)) %in% row.names(GenomicRanges::mcols(overlapped)))
    if (length(indexes) > 1){
      GenomicRanges::mcols(vars[indexes,])$type <- "overlap_indel"
    }

    # Filter
    indexes <- which(mcolumns$type %in% c("ht", "hm")
                     & mcolumns$total.depth >= min.total.depth
                     & (!mcolumns$indel | !exclude.indels) )
    vars <- vars[indexes]

  } else {
    GenomicRanges::mcols(vars) <- cbind(GenomicRanges::mcols(vars), data.frame("indel" = logical(), "type" = character()))
  }

  return(vars)
}

## ----include=FALSE------------------------------------------------------------
library(knitr)
opts_chunk$set(concordance=FALSE)
knitr::opts_chunk$set(fig.width = 8)
knitr::opts_chunk$set(fig.height = 5)
set.seed(21666641)

## ----getPackage, eval=FALSE---------------------------------------------------
#   if (!requireNamespace("BiocManager", quietly = TRUE))
#       install.packages("BiocManager")
#   BiocManager::install("CNVfilteR")

## ----eval = FALSE-------------------------------------------------------------
#   BiocManager::install("jpuntomarcos/CNVfilteR")

## ----message=FALSE------------------------------------------------------------
library(CNVfilteR)

cnvs.file <- system.file("extdata", "DECoN.CNVcalls.csv", package = "CNVfilteR", mustWork = TRUE)
cnvs.gr <- loadCNVcalls(cnvs.file = cnvs.file, chr.column = "Chromosome", start.column = "Start", end.column = "End", cnv.column = "CNV.type", sample.column = "Sample", genome = "hg19")


## -----------------------------------------------------------------------------
vcf.files <- c(system.file("extdata", "variants.sample1.vcf.gz", package = "CNVfilteR", mustWork = TRUE),
               system.file("extdata", "variants.sample2.vcf.gz", package = "CNVfilteR", mustWork = TRUE))
vcfs <- loadVCFs(vcf.files, cnvs.gr = cnvs.gr, genome = "hg19")

## ----message=FALSE------------------------------------------------------------
results <- filterCNVs(cnvs.gr, vcfs)
names(results)

## -----------------------------------------------------------------------------
results$cnvs[results$cnvs$filter == TRUE]

## -----------------------------------------------------------------------------
results$variantsForEachCNV[["3"]]

## ----fig.wide=TRUE------------------------------------------------------------
plotVariantsForCNV(results, "3")

## ----fig.wide=TRUE------------------------------------------------------------
plotVariantsForCNV(results, "19")

## -----------------------------------------------------------------------------
results$cnvs[results$cnvs$filter != TRUE]

## -----------------------------------------------------------------------------
results$variantsForEachCNV[["14"]]

## ----fig.wide=TRUE------------------------------------------------------------
plotVariantsForCNV(results, "3")

## ----message=FALSE------------------------------------------------------------

cnvs.file <- system.file("extdata", "DECoN.CNVcalls.csv", package = "CNVfilteR", mustWork = TRUE)
cnvs.gr <- loadCNVcalls(cnvs.file = cnvs.file, chr.column = "Chromosome", start.column = "Start", end.column = "End", cnv.column = "CNV.type", sample.column = "Sample", genome = "hg19")


## ----eval=FALSE---------------------------------------------------------------
# cnvs.gr.2 <- loadCNVcalls(cnvs.file = cnvs.file.2, deletion = "CN1", duplication = "CN3", chr.column = "Chromosome", start.column = "Start", end.column = "End", cnv.column = "CNV.type", sample.column = "Sample")

## -----------------------------------------------------------------------------
vcf.files <- c(system.file("extdata", "variants.sample1.vcf.gz", package = "CNVfilteR", mustWork = TRUE),
               system.file("extdata", "variants.sample2.vcf.gz", package = "CNVfilteR", mustWork = TRUE))
vcfs <- loadVCFs(vcf.files, cnvs.gr = cnvs.gr)

## -----------------------------------------------------------------------------
vcfs <- loadVCFs(vcf.files, cnvs.gr = cnvs.gr, vcf.source = "MyCaller", ref.support.field = "RD", alt.support.field = "AD")

## -----------------------------------------------------------------------------
vcf.file3 <- c(system.file("extdata", "variants.sample3.vcf", package = "CNVfilteR", mustWork = TRUE))
vcfs3 <- loadVCFs(vcf.file3, cnvs.gr = cnvs.gr, vcf.source = "MyCaller", list.support.field = "AD")

## -----------------------------------------------------------------------------
regions.to.exclude <- GRanges(seqnames = c("chr3","chr7", "chr7"), ranges = IRanges(c(10068098, 6012870, 142457319), c(10143614, 6048756, 142460923)))
vcfs4 <- loadVCFs(vcf.files, cnvs.gr = cnvs.gr, regions.to.exclude = regions.to.exclude)

## -----------------------------------------------------------------------------
results <- filterCNVs(cnvs.gr, vcfs)
tail(results$cnvs)

## ----fig.height=6, fig.wide=TRUE----------------------------------------------
p <- results$filterParameters
plotScoringModel(expected.ht.mean = p$expected.ht.mean, 
                 expected.dup.ht.mean1 = p$expected.dup.ht.mean1,
                 expected.dup.ht.mean2 = p$expected.dup.ht.mean2,
                 sigmoid.c1 = p$sigmoid.c1, 
                 sigmoid.c2.vector = p$sigmoid.c2.vector)


## ----fig.height=6, fig.wide=TRUE----------------------------------------------
plotScoringModel(expected.ht.mean = p$expected.ht.mean, 
                 expected.dup.ht.mean1 = p$expected.dup.ht.mean1,
                 expected.dup.ht.mean2 = p$expected.dup.ht.mean2,
                 sigmoid.c1 = 1, 
                 sigmoid.c2.vector = p$sigmoid.c2.vector)

## ----fig.height=6, fig.wide=TRUE----------------------------------------------
plotScoringModel(expected.ht.mean = p$expected.ht.mean, 
                 expected.dup.ht.mean1 = p$expected.dup.ht.mean1,
                 expected.dup.ht.mean2 = p$expected.dup.ht.mean2,
                 sigmoid.c1 = p$sigmoid.c1, 
                 sigmoid.c2.vector = c(28, 38.3, 46.7, 53.3, 61.3, 71.3))

## ----fig.wide=TRUE------------------------------------------------------------
plotVariantsForCNV(results, "16")

## ----fig.width=8, fig.height=8, fig.wide=TRUE---------------------------------
cnvs.file <- system.file("extdata", "DECoN.CNVcalls.2.csv",
                         package = "CNVfilteR", mustWork = TRUE)
cnvs.gr.2 <- loadCNVcalls(cnvs.file = cnvs.file, chr.column = "Chromosome",
                          start.column = "Start", end.column = "End", 
                          cnv.column = "CNV.type", sample.column = "Sample",
                          genome = "hg19")
plotAllCNVs(cnvs.gr.2)

## -----------------------------------------------------------------------------
  sessionInfo()

#' getVariantScore
#'
#' @description
#' Returns score for a given allele frequency
#'
#' @details
#' Returns a value between -1 and 1. If the allele frequency increases the
#' evidence of discarding a CNV, then the score is positive. If the allele
#' frequency decreases the evidence for discarding a CNV, the score is negative.
#'
#' The model is based on the fuzzy logic and the score is calculated
#' using sigmoids. See the vignette to get more details.
#'
#' @param freq Variant allele frequency
#' @param expected.ht.mean Expected heterozygous SNV/indel allele frequency
#' @param expected.dup.ht.mean1 Expected heterozygous SNV/indel allele frequency when the variant IS NOT in the same allele than the CNV duplication call
#' @param expected.dup.ht.mean2 Expected heterozygous SNV/indel allele frequency when the variant IS in the same allele than the CNV duplication call
#' @param sigmoid.c1 Sigmoid c1 parameter
#' @param sigmoid.c2.vector Vector containing sigmoid c2 parameters for the six sigmoids functions
#' @param sigmoid.int1 Sigmoid int 1
#' @param sigmoid.int2 Sigmoid int 2
#'
#' @return variant score in the [-1, 1] range
#'
#' @importFrom pracma sigmoid
#'
getVariantScore <- function(freq, expected.ht.mean, expected.dup.ht.mean1, expected.dup.ht.mean2,
                            sigmoid.c1, sigmoid.c2.vector, sigmoid.int1, sigmoid.int2) {

  if (freq <= expected.dup.ht.mean1){
    c2 <- sigmoid.c2.vector[1]
    score <- - pracma::sigmoid(freq , a = sigmoid.c1, b = c2)  # extreme left sigmoid gives evidence of dup suspicius ht > reduces score
  } else if (freq <= sigmoid.int1) {
    c2 <- sigmoid.c2.vector[2]
    score <- - pracma::sigmoid(freq + (c2 - freq)*2, a = sigmoid.c1, b = c2)  # left sigmoid gives evidence of dup suspicius ht > reduces score
  } else if (freq <= expected.ht.mean){
    c2 <- sigmoid.c2.vector[3]
    score <- pracma::sigmoid(freq , a = sigmoid.c1, b = c2)  # central left sigmoid removes evidence of dup suspicius ht > increases score
  } else if (freq <= sigmoid.int2){
    c2 <- sigmoid.c2.vector[4]
    score <- pracma::sigmoid(freq + (c2 - freq)*2 , a = sigmoid.c1, b = c2)  # central right sigmoid removes evidence of dup suspicius ht > increases score
  } else if (freq <= expected.dup.ht.mean2){
    c2 <- sigmoid.c2.vector[5]
    score <- - pracma::sigmoid(freq , a = sigmoid.c1, b = c2)  # right sigmoid gives evidence of dup suspicius ht > reduces score
  } else {
    c2 <- sigmoid.c2.vector[6]
    score <- - pracma::sigmoid(freq + (c2 - freq)*2 , a = sigmoid.c1, b = c2)  # extreme right sigmoid gives evidence of dup suspicius ht > reduces score
  }

  return(score)
}

---
title: "CNVfilteR: Remove false positives of CNV calling tools by using SNV calls"
author: "Jose Marcos Moreno-Cabrera <jmoreno@igtp.cat> and Bernat Gel <bgel@igtp.cat> "
date: "`r doc_date()`"
package: "`r pkg_ver('CNVfilteR')`"
output: 
  BiocStyle::html_document:
    toc: true
vignette: >
  %\VignetteIndexEntry{CNVfilteR vignette}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}  
---

```{r, include=FALSE}
library(knitr)
opts_chunk$set(concordance=FALSE)
knitr::opts_chunk$set(fig.width = 8)
knitr::opts_chunk$set(fig.height = 5)
set.seed(21666641)
```


# Introduction

Many tools for germline copy number variant (CNV) detection from 
NGS data have been developed. Usually, these tools were designed
for different input data like WGS, WES or
panel data, and their performance may depend on the CNV size. Available
benchmarks show that all these tools produce false positives, sometimes 
reaching a very high number of them.

With the aim of reducing the number of false positives,
`r BiocStyle::Biocpkg("CNVfilteR")` identifies those germline CNVs that can 
be discarded. This task is performed by using the germline 
single nucleotide variant (SNV) calls that are usually obtained in 
common NGS pipelines. As VCF field interpretation is key when working
with these files, `r BiocStyle::Biocpkg("CNVfilteR")` specifically supports 
VCFs produced by VarScan2, Strelka/Strelka2, freeBayes, HaplotypeCaller (GATK), 
UnifiedGenotyper (GATK) and Torrent Variant Caller. Additionally, results can be
plotted using the functions provided by the R/Bioconductor packages
[karyoploteR](http://bioconductor.org/packages/karyoploteR/) and 
[CopyNumberPlots](http://bioconductor.org/packages/CopyNumberPlots/).



# Installation

`r BiocStyle::Biocpkg("CNVfilteR")` is a 
[Bioconductor](http://bioconductor.org) package and to install it we have
to use `r BiocStyle::Biocpkg("BiocManager")`.

```{r getPackage, eval=FALSE}
  if (!requireNamespace("BiocManager", quietly = TRUE))
      install.packages("BiocManager")
  BiocManager::install("CNVfilteR")
```


We can also install the package from github to get the latest **devel version**.

``` {r, eval = FALSE}
  BiocManager::install("jpuntomarcos/CNVfilteR")
```


# Quick Start

Below we show a full example that covers the usual steps: CNVs data loading,
SNVs loading, identifying false postives and plotting the results.

First, we can load some CNV tool results:
```{r message=FALSE}
library(CNVfilteR)

cnvs.file <- system.file("extdata", "DECoN.CNVcalls.csv", package = "CNVfilteR", mustWork = TRUE)
cnvs.gr <- loadCNVcalls(cnvs.file = cnvs.file, chr.column = "Chromosome", start.column = "Start", end.column = "End", cnv.column = "CNV.type", sample.column = "Sample", genome = "hg19")

```

Then, we load the SNVs stored in a couple of VCF files. 
```{r }
vcf.files <- c(system.file("extdata", "variants.sample1.vcf.gz", package = "CNVfilteR", mustWork = TRUE),
               system.file("extdata", "variants.sample2.vcf.gz", package = "CNVfilteR", mustWork = TRUE))
vcfs <- loadVCFs(vcf.files, cnvs.gr = cnvs.gr, genome = "hg19")
```
We observe that the function recognized VarScan2 as the source, so fields
were selected and allele frequency consequently. Now we can call 
`filterCNVs()` to identify those CNVs that can be discarded.

```{r message=FALSE }
results <- filterCNVs(cnvs.gr, vcfs)
names(results)
```

And we can check those CNVs that can be filtered out:

```{r}
results$cnvs[results$cnvs$filter == TRUE]
```

As an example, we can observe that the CNV with `cnv.id`=3 contains 4 variants:
2 in favor of discarding it, two against discarding it. If we want 
to know more about the variants falling in a certain CNV we can do:
```{r}
results$variantsForEachCNV[["3"]]
```

Two variants are close to the default expected heterozygous frequency,
0.5, so they obtain a positive score. The other two variants are not 
so clearly close to the default expected duplication value, 0.33, so
they obtain a low negative score. All these default values and others can
be modified in the `filterCNVs()` function.

Finally, we may be interested in plotting the results. For example, we can
plot easily the duplication CNV with `cnv.id`=3 and all the variants falling in
it.

```{r, fig.wide=TRUE}
plotVariantsForCNV(results, "3")
```

We can do the same to plot the deletion CNV with `cnv.id`=19, where all 
variants discard the CNV except one homozygous variant that does not give us any 
information for supporting or discarding the CNV:

```{r, fig.wide=TRUE}
plotVariantsForCNV(results, "19")
```


On the opposite side, we can observe those CNVs that cannot be discarded:
```{r}
results$cnvs[results$cnvs$filter != TRUE]
```

For example, the CNV with `cnv.id`=14 contains one variant. If we get
the variant info, we see that the variant has an allele frequency very close to
the default expected duplication value, 0.66.

```{r}
results$variantsForEachCNV[["14"]]
```

So, no evidence was found for discarding the CNV. We can also plot the CNV and 
the variant:
```{r, fig.wide=TRUE}
plotVariantsForCNV(results, "3")
```




# Loading Copy-Number Data

`r BiocStyle::Biocpkg("CNVfilteR")` functions expect germline CNVs calls to be a
`GRanges` object with a few specificic metadata columns: 

* **cnv** for storing the CNV type: duplication or deletion.
* **sample** for storing the sample name of the CNV.
  
You can create this object yourself, but 
`r BiocStyle::Biocpkg("CNVfilter")` provides the proper function to do this, 
`loadCNVcalls()`. This function can interpret any tsv o csv file by indicating
which columns store the information. For example, in the following code, the
`chr.column` column is stored in the "Chromosome" column of the `cnvs.file`.
```{r message=FALSE}

cnvs.file <- system.file("extdata", "DECoN.CNVcalls.csv", package = "CNVfilteR", mustWork = TRUE)
cnvs.gr <- loadCNVcalls(cnvs.file = cnvs.file, chr.column = "Chromosome", start.column = "Start", end.column = "End", cnv.column = "CNV.type", sample.column = "Sample", genome = "hg19")

```

`loadCNVcalls()` can interpret different types of CNVs. Among other options, 
separator can be selected using the `sep` parameter (defaults to *\\t*),
and first lines can be skipped using the `skip` parameter (defaults to 0). Also,
the value used in `cnv.column` to store the CNV type can be modified
using the `deletion` and `duplication` parameters (defaults to "deletion" and 
"duplication", respectively). If, for example, our `cnv.column` uses "CN1" and
"CN3" for deletion and duplication (respectively), we should indicate 
the function to use these values:
```{r eval=FALSE}
cnvs.gr.2 <- loadCNVcalls(cnvs.file = cnvs.file.2, deletion = "CN1", duplication = "CN3", chr.column = "Chromosome", start.column = "Start", end.column = "End", cnv.column = "CNV.type", sample.column = "Sample")
```


Some CNV tools generate results where the CNV location is stored in a single
column with the format *chr:start-end* (i.e. *1:538001-540000*). In this
case, we can call `loadCNVcalls()` using the `coord.column` instead of the 
`chr.column`, `start.column` and `end.column` columns.



# Loading Variants Data

Common NGS pipelines produce germline variant calling (SNVs or INDELs)
in a VCF file. However, VCF interpretation is 
challenging due to the flexibility provided by the VCF format definition. 
It is not straightforward to interpret correctly the fields in the VCF file 
and compute the allele frequency. `loadVCFs()` interprets automatically 
VCFs produced by VarScan2, Strelka/Strelka2, freeBayes, HaplotypeCaller (GATK),
UnifiedGenotyper (GATK) and Torrent Variant Caller.

In the following example the function recognizes VarScan2 as the source.
```{r }
vcf.files <- c(system.file("extdata", "variants.sample1.vcf.gz", package = "CNVfilteR", mustWork = TRUE),
               system.file("extdata", "variants.sample2.vcf.gz", package = "CNVfilteR", mustWork = TRUE))
vcfs <- loadVCFs(vcf.files, cnvs.gr = cnvs.gr)
```

We can also load the VCF file spicifying how to interpret it, which can be
useful if the VCF was generated by a caller not supported by 
`r BiocStyle::Biocpkg("CNVfilteR")`. For example we can specify the ref/alt 
fields:
```{r }
vcfs <- loadVCFs(vcf.files, cnvs.gr = cnvs.gr, vcf.source = "MyCaller", ref.support.field = "RD", alt.support.field = "AD")
```

Alternatively, we can set the `list.support.field` parameter so that field
will be loaded assuming that it is a list in this order: reference allele, 
alternative allele. As an example:
```{r}
vcf.file3 <- c(system.file("extdata", "variants.sample3.vcf", package = "CNVfilteR", mustWork = TRUE))
vcfs3 <- loadVCFs(vcf.file3, cnvs.gr = cnvs.gr, vcf.source = "MyCaller", list.support.field = "AD")
```

## VCF free of artifacts

CNVfilteR uses SNVs to identify false-positive CNV calls. Therefore, its 
performance depends on the SNV calls quality. **We recommend using VCF files 
free of false-positive SNVs** (as possible) to improve CNVfilteR accuracy.
Some considerations can be followed in order to provide reliable SNVs to 
CNVfilteR.

  

### Minimun total depth

Use the `min.total.depth` parameter to discard SNVs with low depth coverage in
the `loadVCFs` function.  The default
value is 10, which may be appropriate in many WGS samples, but
**this value should be adapted to your experiment conditions**. For 
example, we used a `min.total.depth`
of 30 when using CNVfilteR on panel (targeted-enrinched) samples with high 
coverage and VarScan2 as SNV caller.


### Regions to exclude

Low complexity and repetitive regions are genome areas where SNV callers 
(also CNV callers) perform poorly. If possible, ignore these regions when using
CNVfilteR. We can exclude
those complex regions that have already known alignement artifacts 
with the parameter `regions.to.exclude`. 
In this example, we exclude PMS2, PRSS1, and
FANCD2 genes because they are pseudogenes with alignments artifacts:
```{r}
regions.to.exclude <- GRanges(seqnames = c("chr3","chr7", "chr7"), ranges = IRanges(c(10068098, 6012870, 142457319), c(10143614, 6048756, 142460923)))
vcfs4 <- loadVCFs(vcf.files, cnvs.gr = cnvs.gr, regions.to.exclude = regions.to.exclude)
```


### INDELs excluded by default

Also, the parameter `exclude.indels` indicates whether to exclude INDELs when 
loading the variants. TRUE is the default and **recommended** value given 
that INDELs allele frequency varies differently than SNVs. Including
INDELs may allow the algorithm to identify more CNVs to discard with a greater
risk of identifying them wrongly. Additionally, any SNV overlapping an INDEL
will be ignored because the SNV allele frequency may be affected in that region.


## Other settings

The function `loadVCFs()` also adapts to different needs. If `sample.names` parameter is
not provided, the sample names included in the VCF itself will be used. 
Both single-sample and multi-sample VCFs are accepted, but when 
multi-sample VCFs are used, `sample.names` parameter must be NULL.

If VCF is not compressed with bgzip, the function compresses it and generates
the .gz file. If .tbi file does not exist for a given VCF file, the function
also generates it. All files are generated in a temporary folder.

See `loadVCFs()` documentation to see other parameters info.


## Limitations

Currlently CNVfilteR does not support mutiallelic sites in VCF files, 
such as `chr3 193372598 .;. TTA T,TTT`. As an easy work around,
mutiallelic sites can be split by using
[bcftools](https://samtools.github.io/bcftools/): 
`bcftools norm -N -m -both yourSample.vcf > splitSample.vcf`


# Identifying false positives

The task of identifying false positives is performed by the `filterCNVs()`
function. It checks all the variants (SNVs and optionally INDELs) falling in
each CNV present in `cnvs.gr` to identify those CNVs that can be filtered out. It
returns an S3 object with 3 elements: `cnvs`, `variantsForEachCNV` and 
`filterParameters`:

```{r}
results <- filterCNVs(cnvs.gr, vcfs)
tail(results$cnvs)
```


Observe that **those CNVs that can be filtered out have the value TRUE in the 
column `filter`**. `r BiocStyle::Biocpkg("CNVfilteR")` employs two
different strategies for identifying those CNVs:

 * A **deletion CNV** can be filtered out if there is at least 
 `ht.deletions.threshold`% of heterozygous variants in
 the CNV. Default `ht.deletions.threshold` value is 30, so 30% is required.
 * A **duplication CNV** can be filtered out if the total `score` is >= 
 `dup.threshold.score` after computing all 
 heterozygous variants falling in that CNV. Default `dup.threshold.score` value
 is 0.5. How the score is computed for each variant is explained in 
 the next section.




## Scoring model for duplication CNVs 

The scoring model for determining whether a certain duplication CNV can be 
discarded
is based on the allele frequency for each heterozygous variant falling in
that CNV:

 * In common conditions with no presence of a duplication CNV, the allele 
 frequency of a heterozygous variant is expected to be close to 50% 
 (`expected.ht.mean`). So, a variant with an allele frequency close to 50%
 gives us evidence of the non-existence of a duplication CNV, so the CNV could 
 be discarded.
 * On the opposite side, if the variant occurs in the same region of a 
certain duplication CNV, the allele frequency is expected to be close to 33.3%
(`expected.dup.ht.mean1`) when the variant **is not** in the same allele 
 than the duplication CNV, and 66.6% (`expected.dup.ht.mean2`) when the variant 
 **is** in the same allele than 
 the duplication CNV call. So, a variant with an allele frequency close to 
 33.3% or 66.6% gives us evidence of the existence of duplication CNV.



Although we can expect that most of the variants are close to the expected means
(33.3%, 50%, and 66.6%), many of them can be far from any expected mean. The 
scoring model implemented in the `filterCNVs()` function measures
the evidence - for discarding a certain CNV - using
a scoring model. The scoring model is based on the fuzzy logic, where elements 
can have any value between 1 (True) and 0 (False). Following this idea, 
**each variant will be scored with a value between 0 and 1 depending on 
how close is the allele frequency to the nearest expected mean**. 

 * For those variants with an allele frequency close to the expected mean when
 no duplication CNV occurs (defaults 50%),
 the score will be positive in the interval [0, 1].
 * For those variants with an allele frequency close to the expected mean when
 a duplication CNV occurs (defaults 33.3%, 66.6%), the score will be negative 
 in the interval [-1, 0].

The total `score` is computed among all the variants falling in the CNV. If the 
`score` is greater than the `dup.threshold.score`, the CNV can be discarded.

A common way of applying the fuzzy logic is using the sigmoid function. 
CNVfilteR uses the sigmoid function implemented in the
[pracma](https://cran.r-project.org/web/packages/pracma/index.html) package, 
which is defined as
$$
\begin{aligned}
 y = 1/(1 + e^{-c1(x−c2)})
\end{aligned}
$$

The scoring model is built on 6 sigmoids defined on 6 different intervals. The
c1 parameter is 2 by default (`sigmoid.c1`), and the c2 parameter 
is defined for the 6 sigmoids (`sigmoid.c2.vector`).

 * First sigmoid: interval [20, `expected.dup.ht.mean1`], c2=28
 * Second sigmoid: interval [`expected.dup.ht.mean1`, `sigmoid.int1`], c2=38.3
 * Third sigmoid: interval [`sigmoid.int1`, `expected.ht.mean`], c2=44.7
 * Fourth sigmoid: interval [`expected.ht.mean`, `sigmoid.int2`], c2=55.3
 * Fifth sigmoid: interval [`sigmoid.int2`, `expected.dup.ht.mean2`], c`=61.3
 * Sixth sigmoid: interval [`expected.dup.ht.mean2`, 80], c2=71.3
 
Where `sigmoid.int1` is the mean between `expected.dup.ht.mean1` and 
`expected.ht.mean`, and `sigmoid.int2` is the mean between 
`expected.dup.ht.mean2` and `expected.ht.mean`.
 
The scoring model can be plotted using the `plotScoringModel()` function.
```{r, fig.height=6, fig.wide=TRUE}
p <- results$filterParameters
plotScoringModel(expected.ht.mean = p$expected.ht.mean, 
                 expected.dup.ht.mean1 = p$expected.dup.ht.mean1,
                 expected.dup.ht.mean2 = p$expected.dup.ht.mean2,
                 sigmoid.c1 = p$sigmoid.c1, 
                 sigmoid.c2.vector = p$sigmoid.c2.vector)

```

And the scoring model can be modified when calling the `filterCNVs()` function. 
Let's see how the model changes when we modify the parameter `sigmoid.c1` 
(1 instead of 2): 
```{r, fig.height=6, fig.wide=TRUE}
plotScoringModel(expected.ht.mean = p$expected.ht.mean, 
                 expected.dup.ht.mean1 = p$expected.dup.ht.mean1,
                 expected.dup.ht.mean2 = p$expected.dup.ht.mean2,
                 sigmoid.c1 = 1, 
                 sigmoid.c2.vector = p$sigmoid.c2.vector)
```

We can also modify the `sigmoid.c2.vector` parameter for each sigmoid function. For example, to 
make the central sigmoids narrower:
```{r, fig.height=6, fig.wide=TRUE}
plotScoringModel(expected.ht.mean = p$expected.ht.mean, 
                 expected.dup.ht.mean1 = p$expected.dup.ht.mean1,
                 expected.dup.ht.mean2 = p$expected.dup.ht.mean2,
                 sigmoid.c1 = p$sigmoid.c1, 
                 sigmoid.c2.vector = c(28, 38.3, 46.7, 53.3, 61.3, 71.3))
```

## The margin.pct parameter

Many CNV callers produce inaccurate CNV calls. These inaccurate CNV calls are 
more likely to be true (to overlap the real CNV) in the middle of the CNV than 
in the extremes. So, the `margin.pct` parameter defines the percentage of CNV 
(from each CNV limit) where SNVs will be ignored. By default, only 10% of SNVs 
from each CNV extreme will be ignored. This `margin.pct` parameter can be 
modified to better adapt it to your CNV caller. For example, we observed that 
DECoN produced very accurate CNV calls in our genes panel dataset, so 
`margin.pct` value was updated to 0 in this context.

Summarizing, variants in the CNV call but close to the ends of the CNV call will
be ignored. `margin.pct` defines the percentage of CNV length, located at 
each CNV limit, where variants will be ignored. For example, for a CNV 
chr1:1000-2000 and a `margin.pct` value of 10,
variants within chr1:1000-1100 and chr1:1900-2000 will be ignored.




# Plotting results

We can plot easily a certain CNV and the variants in it. For example,  the 
duplication CNV with `cnv.id`=17 can be plotted as follows:
```{r, fig.wide=TRUE}
plotVariantsForCNV(results, "16")
```

Some parameters can be customized, like `points.cex` and `points.pch`. It is 
also possible to plot all CNVs in a global schema where all the chromosomes are
plotted:
```{r, fig.width=8, fig.height=8, fig.wide=TRUE}
cnvs.file <- system.file("extdata", "DECoN.CNVcalls.2.csv",
                         package = "CNVfilteR", mustWork = TRUE)
cnvs.gr.2 <- loadCNVcalls(cnvs.file = cnvs.file, chr.column = "Chromosome",
                          start.column = "Start", end.column = "End", 
                          cnv.column = "CNV.type", sample.column = "Sample",
                          genome = "hg19")
plotAllCNVs(cnvs.gr.2)
```

Note that if a CNV is too small, it will not be visible when calling 
`plotAllCNVs()`.


# Session Info
```{r}
  sessionInfo()
```
  

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotAllCNVs.R
\name{plotAllCNVs}
\alias{plotAllCNVs}
\title{plotAllCNVs}
\usage{
plotAllCNVs(cnvs.gr, genome = "hg19")
}
\arguments{
\item{cnvs.gr}{\code{GRanges} containing al CNV definitions returned by \code{filterCNVs} or \code{loadCNVcalls} functions.}

\item{genome}{The name of the genome. (Defaults to "hg19")}
}
\value{
invisibly returns a \code{karyoplot} object
}
\description{
Plots all CNVs on chromosome ideograms
}
\details{
Plots all CNVs defined at \code{cnvs.gr} on a view of horizontal ideograms representing all chromosomes.
}
\examples{
cnvs.file <- system.file("extdata", "DECoN.CNVcalls.2.csv", package = "CNVfilteR", mustWork = TRUE)
cnvs.gr <- loadCNVcalls(cnvs.file = cnvs.file, chr.column = "Chromosome", start.column = "Start", end.column = "End", cnv.column = "CNV.type", sample.column = "Sample")

# Plot all CNVs
plotAllCNVs(cnvs.gr)


}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotVariantsForCNV.R
\name{plotVariantsForCNV}
\alias{plotVariantsForCNV}
\title{plotVariantsForCNV}
\usage{
plotVariantsForCNV(
  cnvfilter.results,
  cnv.id,
  points.cex = 1,
  points.pch = 19,
  legend.x.pos = 0.08,
  legend.y.pos = 0.25,
  legend.cex = 0.8,
  legend.text.width = NULL,
  legend.show = TRUE,
  karyotype.cex = 1,
  cnv.label.cex = 1,
  x.axis.bases.cex = 0.7,
  x.axis.bases.digits = 5,
  y.axis.title.cex = 0.8,
  y.axis.label.cex = 0.8,
  cnv.zoom.margin = TRUE
)
}
\arguments{
\item{cnvfilter.results}{S3 object returned by \code{filterCNVs} function}

\item{cnv.id}{CNV id for which to plot variants}

\item{points.cex}{Points cex (size). (Defaults to 1)}

\item{points.pch}{Points pch (symbol). (Defaults to 19)}

\item{legend.x.pos}{Legend x position. (Defaults to 0.08)}

\item{legend.y.pos}{Legend y position. (Defaults to 0.25)}

\item{legend.cex}{Legend cex. (Defaults to 0.8)}

\item{legend.text.width}{Legend text width (Defaults to NULL)}

\item{legend.show}{Whether to show the legend (Defaults to TRUE)}

\item{karyotype.cex}{karyotype cex: affects top title and chromosome text (at bottom). (Defaults to 1)}

\item{cnv.label.cex}{"CNV" text cex. (Defaults to 1)}

\item{x.axis.bases.cex}{X-axis bases position cex. (Defaults to 0.7)}

\item{x.axis.bases.digits}{X-axis bases position number of digits. (Defaults to 5)}

\item{y.axis.title.cex}{Y-axis title cex. (Defaults to 0.8)}

\item{y.axis.label.cex}{Y-axis labels cex. (Defaults to 0.8)}

\item{cnv.zoom.margin}{If TRUE, the zoom leaves an small margin at both sides of the CNV. False otherwise. (Defaults to TRUE)}
}
\value{
invisibly returns a \code{karyoplot} object
}
\description{
Plots a CNV with all the variants in it
}
\examples{
# Load CNVs data
cnvs.file <- system.file("extdata", "DECoN.CNVcalls.csv", package = "CNVfilteR", mustWork = TRUE)
cnvs.gr <- loadCNVcalls(cnvs.file = cnvs.file, chr.column = "Chromosome", start.column = "Start", end.column = "End", cnv.column = "CNV.type", sample.column = "Sample")

# Load VCFs data
vcf.files <- c(system.file("extdata", "variants.sample1.vcf.gz", package = "CNVfilteR", mustWork = TRUE),
               system.file("extdata", "variants.sample2.vcf.gz", package = "CNVfilteR", mustWork = TRUE))
vcfs <- loadVCFs(vcf.files, cnvs.gr = cnvs.gr)

# Filter CNVs
results <- filterCNVs(cnvs.gr, vcfs)

# Check CNVs that can be filtered out
as.data.frame(results$cnvs[results$cnvs$filter == TRUE])

# Plot one of them
plotVariantsForCNV(results, "3")


}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/loadVCFs.R
\name{auxProcessVariants}
\alias{auxProcessVariants}
\title{auxProcessVariants}
\usage{
auxProcessVariants(
  vars,
  cnvGR,
  heterozygous.range,
  homozygous.range,
  min.total.depth,
  exclude.indels,
  regions.to.exclude
)
}
\arguments{
\item{vars}{\code{GRanges} object containing variants for a certain sample.}

\item{cnvGR}{\code{GRanges} object containg CNV calls for a certain sample.}

\item{heterozygous.range}{Heterozygous range. Variants not in the homozygous/heterozygous intervals will be excluded.}

\item{homozygous.range}{Homozygous range. Variants not in the homozygous/heterozygous intervals will be excluded.}

\item{min.total.depth}{Minimum total depth. Variants under this value will be excluded.}

\item{exclude.indels}{Whether to exclude indels when loading the variants. TRUE is the recommended value given that indels frequency varies in a different way than SNVs.}

\item{regions.to.exclude}{A \code{GRanges} object defining the regions for which the variants should be excluded.}
}
\value{
Processed \code{vars}
}
\description{
Auxiliar function called by \code{loadVCFs} to process variants
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getVariantScore.R
\name{getVariantScore}
\alias{getVariantScore}
\title{getVariantScore}
\usage{
getVariantScore(
  freq,
  expected.ht.mean,
  expected.dup.ht.mean1,
  expected.dup.ht.mean2,
  sigmoid.c1,
  sigmoid.c2.vector,
  sigmoid.int1,
  sigmoid.int2
)
}
\arguments{
\item{freq}{Variant allele frequency}

\item{expected.ht.mean}{Expected heterozygous SNV/indel allele frequency}

\item{expected.dup.ht.mean1}{Expected heterozygous SNV/indel allele frequency when the variant IS NOT in the same allele than the CNV duplication call}

\item{expected.dup.ht.mean2}{Expected heterozygous SNV/indel allele frequency when the variant IS in the same allele than the CNV duplication call}

\item{sigmoid.c1}{Sigmoid c1 parameter}

\item{sigmoid.c2.vector}{Vector containing sigmoid c2 parameters for the six sigmoids functions}

\item{sigmoid.int1}{Sigmoid int 1}

\item{sigmoid.int2}{Sigmoid int 2}
}
\value{
variant score in the [-1, 1] range
}
\description{
Returns score for a given allele frequency
}
\details{
Returns a value between -1 and 1. If the allele frequency increases the
evidence of discarding a CNV, then the score is positive. If the allele
frequency decreases the evidence for discarding a CNV, the score is negative.

The model is based on the fuzzy logic and the score is calculated
using sigmoids. See the vignette to get more details.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/loadVCFs.R
\name{loadVCFs}
\alias{loadVCFs}
\title{loadVCFs}
\usage{
loadVCFs(
  vcf.files,
  sample.names = NULL,
  cnvs.gr,
  min.total.depth = 10,
  regions.to.exclude = NULL,
  vcf.source = NULL,
  ref.support.field = NULL,
  alt.support.field = NULL,
  list.support.field = NULL,
  homozygous.range = c(90, 100),
  heterozygous.range = c(28, 72),
  exclude.indels = TRUE,
  genome = "hg19",
  exclude.non.canonical.chrs = TRUE,
  verbose = TRUE
)
}
\arguments{
\item{vcf.files}{vector of VCFs paths. Both .vcf and .vcf.gz extensions are allowed.}

\item{sample.names}{Sample names vector containing sample names for each \code{vcf.files}. If NULL, sample name will be obtained from the VCF sample column.  (Defaults to NULL)}

\item{cnvs.gr}{\code{GRanges} object containg CNV calls. Call \code{loadCNVcalls} to obtain it. Only those variants in regions affected by CNVs will be loaded to speed up the load.}

\item{min.total.depth}{Minimum total depth. Variants under this value will be excluded. (Defaults to 10)}

\item{regions.to.exclude}{A \code{GRanges} object defining the regions for which the variants should be excluded.
Useful for defining known difficult regions like pseudogenes where the allele frequency is not trustable. (Defaults to NULL)}

\item{vcf.source}{VCF source, i.e., the variant caller used to generate the VCF file. If set, the \code{loadSNPsFromVCF} function will not try to recognize the source. (Defaults to NULL)}

\item{ref.support.field}{Reference allele depth field. (Defaults to NULL)}

\item{alt.support.field}{Alternative allele depth field. (Defaults to NULL)}

\item{list.support.field}{Allele support field in a list format: reference allele, alternative allele. (Defaults to NULL)}

\item{homozygous.range}{Homozygous range. Variants not in the homozygous/heterozygous intervals will be excluded. (Defaults to \code{c(90, 100)})}

\item{heterozygous.range}{Heterozygous range. Variants not in the homozygous/heterozygous intervals will be excluded. (Defaults to \code{c(28, 72)})}

\item{exclude.indels}{Whether to exclude indels when loading the variants. TRUE is the recommended value given that indels frequency varies in a different way than SNVs. (Defaults to TRUE)}

\item{genome}{The name of the genome. (Defaults to "hg19")}

\item{exclude.non.canonical.chrs}{Whether to exclude non canonical chromosomes (Defaults to TRUE)}

\item{verbose}{Whether to show information messages. (Defaults to TRUE)}
}
\value{
A list where names are the sample names, and values are the \code{GRanges} objects for each sample.
}
\description{
Loads VCFs files
}
\details{
Loads VCF files and computes alt allele frequency for each variant. It uses
\code{\link{loadSNPsFromVCF}} function load the data and identify the
correct VCF format for allele frequency computation.

If sample.names is not provided, the sample names included in the VCF itself
will be used. Both single-sample and multi-sample VCFs are accepted, but when
multi-sample VCFs are used, sample.names parameter must be NULL.

If vcf is not compressed with bgzip, the function compresses it and generates
the .gz file. If .tbi file does not exist for a given VCF file, the function
also generates it. All files are generated in a temporary folder.
}
\note{
Important: Compressed VCF must be compressed with
[bgzip ("block gzip") from Samtools htslib](http://www.htslib.org/doc/bgzip.html)
and not using the standard Gzip utility.
}
\examples{
# Load CNVs data (required by loadVCFs to speed up the load process)
cnvs.file <- system.file("extdata", "DECoN.CNVcalls.csv", package = "CNVfilteR", mustWork = TRUE)
cnvs.gr <- loadCNVcalls(cnvs.file = cnvs.file, chr.column = "Chromosome", start.column = "Start", end.column = "End", cnv.column = "CNV.type", sample.column = "Sample")

# Load VCFs data
vcf.files <- c(system.file("extdata", "variants.sample1.vcf.gz", package = "CNVfilteR", mustWork = TRUE),
               system.file("extdata", "variants.sample2.vcf.gz", package = "CNVfilteR", mustWork = TRUE))
vcfs <- loadVCFs(vcf.files, cnvs.gr = cnvs.gr)


}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/loadSNPsFromVCF.R
\name{loadSNPsFromVCF}
\alias{loadSNPsFromVCF}
\title{loadSNPsFromVCF}
\usage{
loadSNPsFromVCF(
  vcf.file,
  vcf.source = NULL,
  ref.support.field = NULL,
  alt.support.field = NULL,
  list.support.field = NULL,
  regions.to.filter = NULL,
  genome = "hg19",
  exclude.non.canonical.chrs = TRUE,
  verbose = TRUE
)
}
\arguments{
\item{vcf.file}{VCF file path}

\item{vcf.source}{VCF source, i.e., the variant caller used to generate the VCF file. If set, the function will not try to recognize the source. (Defaults to NULL)}

\item{ref.support.field}{Reference allele depth field. (Defaults to NULL)}

\item{alt.support.field}{Alternative allele depth field. (Defaults to NULL)}

\item{list.support.field}{Allele support field in a list format: reference allele, alternative allele. (Defaults to NULL)}

\item{regions.to.filter}{The regions to which limit the VCF import. It can be used to speed up the import process. (Defaults to NULL)}

\item{genome}{The name of the genome (Defaults to "hg19")}

\item{exclude.non.canonical.chrs}{Whether to exclude non canonical chromosomes (Defaults to TRUE)}

\item{verbose}{Whether to show information messages. (Defaults to TRUE)}
}
\value{
A list where names are sample names, and values are \code{GRanges} objects containing the variants for each sample, including the following metadata columns:
\itemize{
 \item \code{ref.support}: Reference allele depth field
 \item \code{alt.support}: Alternative allele depth field
 \item \code{alt.freq}: allelic frequency
 \item \code{total.depth}: total depth
}
}
\description{
Loads SNPs (SNVs/indels) from a VCF file
}
\details{
Given a VCF file path, the function recognizes the variant caller source to decide which fields should be used to calculate
ref/alt support and allelic frequency (see \code{return}). Current supported variant callers are VarScan2, Strelka/Strelka2, freebayes,
HaplotypeCaller, UnifiedGenotyper and Torrent Variant Caller.

Optionally, the fields where the data is stored can be manually set by using the parameters \code{ref.support.field},
\code{alt.support.field} and \code{list.support.field}

Requirement: a TabixFile (.tbi) should exists in the same directory of the VCF file.
}
\examples{
vcf.file <- system.file("extdata", "variants.sample1.vcf.gz", package = "CNVfilteR", mustWork = TRUE)
vcf <- loadSNPsFromVCF(vcf.file)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/filterCNVs.R
\name{filterCNVs}
\alias{filterCNVs}
\title{filterCNVs}
\usage{
filterCNVs(
  cnvs.gr,
  vcfs,
  expected.ht.mean = 50,
  expected.dup.ht.mean1 = 33.3,
  expected.dup.ht.mean2 = 66.6,
  sigmoid.c1 = 2,
  sigmoid.c2.vector = c(28, 38.3, 44.7, 55.3, 61.3, 71.3),
  dup.threshold.score = 0.5,
  ht.deletions.threshold = 30,
  verbose = FALSE,
  margin.pct = 10
)
}
\arguments{
\item{cnvs.gr}{\code{GRanges} containing CNVs to be filtered out. Use \code{loadCNVcalls} to load them.}

\item{vcfs}{List of \code{GRanges} containing all variants (SNV/indel) obtaining with the \code{loadVCFs} function.}

\item{expected.ht.mean}{Expected heterozygous SNV/indel allele frequency (defaults to 50)}

\item{expected.dup.ht.mean1}{Expected heterozygous SNV/indel allele frequency when the variant IS NOT in the same allele than the CNV duplication call. (defaults to 33.3)}

\item{expected.dup.ht.mean2}{Expected heterozygous SNV/indel allele frequency when the variant IS in the same allele than the CNV duplication call. (defaults to 66.6)}

\item{sigmoid.c1}{Sigmoid c1 parameter. (defaults to 2)}

\item{sigmoid.c2.vector}{Vector containing sigmoid c2 parameters for the six sigmoids functions. (defaults to c(28, 38.3, 44.7, 55.3, 61.3, 71.3))}

\item{dup.threshold.score}{Limit value to decide if a CNV duplication can be filtered out or not. A CNV duplication can be filtered out if the total score computed from heterozygous variants in the CNV is equal or greater than \code{dup.threshold.score}.  (defaults to 0.5)}

\item{ht.deletions.threshold}{Minimum percentage of heterozygous variants falling in a CNV deletion to filter that CNV. (defaults to 30)}

\item{verbose}{Whether to show information messages. (defaults to TRUE)}

\item{margin.pct}{Variants in the CNV but close to the ends of the CNV will be ignored. \code{margin.pct} defines the percentage
of CNV length, located at each CNV limit, where variants will be ignored. For example, for a CNV chr1:1000-2000 and
a \code{margin.pct} value of 10, variants within chr1:1000-1100 and chr1:1900-2000 will be ignored.}
}
\value{
A S3 object with 3 elements:
\itemize{
\item \code{cnvs}: \code{GRanges} with the input CNVs and the meta-columns added during the call:
  \itemize{
   \item \code{cnv.id}: CNV id
   \item \code{filter}: Set to TRUE if the CNV can be filtered out
   \item \code{n.total.variants}: Number of variants in the CNV
   \item \code{n.hm.variants}: Number of homozygous variants. They do not give any evidenced for confirming or discarding the CNV.
   \item \code{n.ht.discard.CNV}: For a CNV duplication, number of heterozygous variants in that discard the CNV (those with a positive score)
   \item \code{n.ht.confirm.CNV}: For a CNV duplication, number of heterozygous variants that confirm the CNV (those with a negative score)
   \item \code{ht.pct}: Percentage of heterozygous variants for deletion CNVs
   \item \code{score}: total score when computing all the variants scores
  }
\item \code{variantsForEachCNV}: named list where each name correspond to a CNV id and the value is a \code{data.frame} with all variants falling in that CNV
\item \code{filterParameters}: input parameters used for filtering
}
}
\description{
Identifies those copy number calls that can be filtered out
}
\details{
Checks all the variants (SNV and optionally INDELs) in each CNV present in \code{cnvs.gr} to decide whether a CNV can be filtered out or not.
It returns an S3 object with 3 elments: \code{cnvs}, \code{variantsForEachCNV} and \code{filterParameters}. See return section for further details.

A CNV deletion can be filtered out if there is at least \code{ht.deletions.threshold}% of heterozygous variants in the CNV.
A CNV duplication can be filtered out if the \code{score} is >= \code{dup.threshold.score} after computing all heterozygous variants falling in the CNV.

If a CNV can be filtered out, then the value TRUE is set in the \code{filter} column of the \code{cnvs} element.
}
\examples{
# Load CNVs data
cnvs.file <- system.file("extdata", "DECoN.CNVcalls.csv", package = "CNVfilteR", mustWork = TRUE)
cnvs.gr <- loadCNVcalls(cnvs.file = cnvs.file, chr.column = "Chromosome", start.column = "Start", end.column = "End", cnv.column = "CNV.type", sample.column = "Sample")

# Load VCFs data
vcf.files <- c(system.file("extdata", "variants.sample1.vcf.gz", package = "CNVfilteR", mustWork = TRUE),
               system.file("extdata", "variants.sample2.vcf.gz", package = "CNVfilteR", mustWork = TRUE))
vcfs <- loadVCFs(vcf.files, cnvs.gr = cnvs.gr)

# Filter CNVs
results <- filterCNVs(cnvs.gr, vcfs)

# Check CNVs that can be filtered out
as.data.frame(results$cnvs[results$cnvs$filter == TRUE])


}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/loadSNPsFromVCF.R
\name{auxGetVcfSource}
\alias{auxGetVcfSource}
\title{auxGetVcfSource}
\usage{
auxGetVcfSource(vcf.source = NULL, vcf.file)
}
\arguments{
\item{vcf.source}{VCF source. Leave NULL to allow the function to recognize it. Otherwise, the function will not try to recognize the source. (Defaults to NULL)}

\item{vcf.file}{VCF file path}
}
\value{
VCF source
}
\description{
Obtains VCF source from a given VCF file path. Auxiliar function used by \code{loadSNPsFromVCF}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotScoringModel.R
\name{plotScoringModel}
\alias{plotScoringModel}
\title{plotVariantsForCNV}
\usage{
plotScoringModel(
  expected.ht.mean,
  expected.dup.ht.mean1,
  expected.dup.ht.mean2,
  sigmoid.c1,
  sigmoid.c2.vector
)
}
\arguments{
\item{expected.ht.mean}{Expected heterozygous SNV/indel allele frequency}

\item{expected.dup.ht.mean1}{Expected heterozygous SNV/indel allele frequency when the variant IS NOT in the same allele than the CNV duplication call}

\item{expected.dup.ht.mean2}{Expected heterozygous SNV/indel allele frequency when the variant IS in the same allele than the CNV duplication call}

\item{sigmoid.c1}{Sigmoid c1 parameter}

\item{sigmoid.c2.vector}{Vector containing sigmoid c2 parameters for the six sigmoids functions}
}
\value{
nothing
}
\description{
Plots scoring model used for CNV duplications
}
\examples{
# Load CNVs data
cnvs.file <- system.file("extdata", "DECoN.CNVcalls.csv", package = "CNVfilteR", mustWork = TRUE)
cnvs.gr <- loadCNVcalls(cnvs.file = cnvs.file, chr.column = "Chromosome", start.column = "Start", end.column = "End", cnv.column = "CNV.type", sample.column = "Sample")

# Load VCFs data
vcf.files <- c(system.file("extdata", "variants.sample1.vcf.gz", package = "CNVfilteR", mustWork = TRUE),
               system.file("extdata", "variants.sample2.vcf.gz", package = "CNVfilteR", mustWork = TRUE))
vcfs <- loadVCFs(vcf.files, cnvs.gr = cnvs.gr)

# Filter CNVs
results <- filterCNVs(cnvs.gr, vcfs)

# Plot scoring model for duplication CNVs
p <- results$filterParameters
plotScoringModel(expected.ht.mean = p$expected.ht.mean, expected.dup.ht.mean1 = p$expected.dup.ht.mean1,
                  expected.dup.ht.mean2 = p$expected.dup.ht.mean2, sigmoid.c1 = p$sigmoid.c1, sigmoid.c2.vector = p$sigmoid.c2.vector)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{auxAddCNcolumn}
\alias{auxAddCNcolumn}
\title{auxAddCNcolumn}
\usage{
auxAddCNcolumn(cnvs.gr)
}
\arguments{
\item{cnvs.gr}{\code{data.frame or GRanges} containing the column 'cnv' with "deletion" or "duplication" as values}
}
\value{
input \code{cnvs.gr} with the new column 'cn'
}
\description{
Adds a 'cn' column to the \code{cnvs.gr} data.frame or GRanges.
}
\details{
For each row, \code{cn} column is filled with 1 if \code{cnv} is "deletion", 3 if \code{cnv} is "duplication"
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/loadCNVcalls.R
\name{loadCNVcalls}
\alias{loadCNVcalls}
\title{loadCNVcalls}
\usage{
loadCNVcalls(
  cnvs.file,
  chr.column,
  start.column,
  end.column,
  coord.column = NULL,
  cnv.column,
  sample.column,
  sample.name = NULL,
  gene.column = NULL,
  deletion = "deletion",
  duplication = "duplication",
  ignore.unexpected.rows = FALSE,
  sep = "\\t",
  skip = 0,
  genome = "hg19",
  exclude.non.canonical.chrs = TRUE,
  check.names.cnvs.file = FALSE
)
}
\arguments{
\item{cnvs.file}{Path to csv/tsv file containing the CNV calls.}

\item{chr.column}{Which column stores the chr location of the CNV.}

\item{start.column}{Which column stores the start location of the CNV.}

\item{end.column}{Which column stores the end location of the CNV.}

\item{coord.column}{CNV location in the chr:start-end format. Example: "1:538001-540000". If NULL, \code{chr.column},
\code{start.column} and {end.column} columns will be used. (Defaults to NULL)}

\item{cnv.column}{Which column stores the type of CNV (deletion or duplication).}

\item{sample.column}{Which column stores the sample name.}

\item{sample.name}{Sample name for all CNVs defined in \code{cnvs.file}. If set, \code{sample.column} is ignored (Defaults to NULL)}

\item{gene.column}{Which columns store the gene or genes affected (optional). (Defaults to NULL)}

\item{deletion}{Text used in the \code{cnv.column} to represent deletion CNVs. Multiple values are also allowed, for example: c("CN0", "CN1"). (Defaults to "deletion")}

\item{duplication}{Text used in the \code{cnv.column} to represent duplication CNVs.  Multiple values are also allowed, for example: c("CN3", "CN4") (Defaults to "duplication")}

\item{ignore.unexpected.rows}{Whether to ignore the rows which CNV \code{cnv.column} value is different to \code{deletion} or \code{duplication} values (Defaults to FALSE). It is useful for processing output from callers like LUMPY or Manta (they call also events that are not CNVs)}

\item{sep}{Separator symbol to load the csv/tsv file. (Defaults to "\\t")}

\item{skip}{Number of rows that should be skipped when reading the csv/tsv file. (Defaults to 0)}

\item{genome}{The name of the genome. (Defaults to "hg19")}

\item{exclude.non.canonical.chrs}{Whether to exclude non canonical chromosomes (Defaults to TRUE)}

\item{check.names.cnvs.file}{Whether to check \code{cnvs.file} names or not (Defaults to FALSE).  If TRUE then column names in the \code{cnvs.file} are checked to ensure that they are syntactically valid variable names. If necessary they are adjusted (by make.names) so that they are, and also to ensure that there are no duplicates}
}
\value{
A \code{GRanges} with a range per each CNV and the metadata columns:
\itemize{
 \item \code{cnv}: type of CNV, "duplication" or "deletion"
 \item \code{sample}: sample name
}

Returns NULL if \code{cnvs.file} has no CNVs
}
\description{
Loads CNV calls from a csv/tsv file
}
\details{
Loads a csv/tsv file containing CNV calls, and transform it into a GRanges with \code{cnv} and \code{sample} metadata columns.
}
\examples{
# Load CNVs data
cnvs.file <- system.file("extdata", "DECoN.CNVcalls.csv", package = "CNVfilteR", mustWork = TRUE)
cnvs.gr <- loadCNVcalls(cnvs.file = cnvs.file, chr.column = "Chromosome", start.column = "Start", end.column = "End", cnv.column = "CNV.type", sample.column = "Sample")


}
